# Generated by Makefile. Do not edit.

commit 823c96ff213760bf3e4e9f26c7b456b1e522b0f2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 10:07:10 2015 -0400

    Update AUTHORS.

commit dee0ffa0a7ea98e33d305b7d56216030a9712448
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 10:00:30 2015 -0400

    Create README on the fly.

commit 4e3686355f73d3b1f69651b5f6a31e6a1e5da2ef
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 09:41:26 2015 -0400

    Set the version to 0.9.1.

commit 2bd12372cef579d5c644b844ffb3b198b51c5bce
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 12:54:59 2015 +0000

    Reformatted the Download section to make it appear better.

commit 2684b41e7d17adb8326a1eb5db58c64c49f4598e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 08:46:40 2015 -0400

    Add Download section content to README.

commit 2ac9865bef5bd7def83272c0e44d5ccc541ddc3b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 5 08:29:25 2015 -0400

    Put the project's old wiki home content into README.

commit e9b71b7d083bddd291f12efd07113d7aec9f87ff
Author: David Tardon <dtardon@redhat.com>
Date:   Sun Apr 5 10:55:49 2015 +0200

    add something to NEWS

commit a833414d6f8a841da968692a9773bd86dc873ed6
Author: David Tardon <dtardon@redhat.com>
Date:   Fri Mar 6 08:33:19 2015 -0500

    match argument and format unit
    
    This makes ixion.sheet work correctly on s390x.

commit 877f3e2fe6b38d320a6732c5d569652b7cbdc872
Author: David Tardon <dtardon@redhat.com>
Date:   Fri Mar 6 14:12:12 2015 +0100

    set correct CPPFLAGS for the python module

commit 9e7763aa51d50b941754ad678fd5ec8e4fe5670f
Author: David Tardon <dtardon@redhat.com>
Date:   Fri Mar 6 10:17:55 2015 +0100

    let python do the arg parsing

commit e7806c150283ed4e7dbbeda82f9408ece9139841
Author: David Tardon <dtardon@redhat.com>
Date:   Fri Mar 6 10:14:01 2015 +0100

    add cast

commit 209bea9422b2e4675cc87eb63ab98790e60a73e7
Author: David Tardon <dtardon@redhat.com>
Date:   Fri Mar 6 09:56:46 2015 +0100

    use METH_NOARGS flag

commit 21e8f74df328006a24096f4587e8d668f75ac185
Author: David Tardon <dtardon@redhat.com>
Date:   Thu Mar 5 17:47:30 2015 +0100

    add missing includes for assert()

commit 6acd183e4db7b8dc4c6336750f01b68de3fb4fb1
Author: David Tardon <dtardon@redhat.com>
Date:   Thu Mar 5 16:26:37 2015 +0100

    fix python test on some platforms
    
    Functions with METH_VARAGS flag (of type PyCFunction) do not take
    keywords. Attempt to use a 3rd argument would access some irrelevant
    data on the stack.

commit a32dad8961413056a10f61881843fa4a895c89c9
Author: David Tardon <dtardon@redhat.com>
Date:   Wed Feb 18 08:42:02 2015 +0100

    fix make distcheck

commit b85f73c1ad4e665e265330d22f3f5c319b58c541
Author: David Tardon <dtardon@redhat.com>
Date:   Wed Feb 18 07:57:58 2015 +0100

    package ixion-python-test.py

commit c940a1c061e98ff0cce8119e6ced2565996e6f5a
Author: David Tardon <dtardon@redhat.com>
Date:   Mon Feb 9 21:20:04 2015 +0100

    add compile to .gitignore

commit a359ee803fb24a3c190941974bc61dc3ff4443d6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 20:29:19 2015 -0500

    Add python doc files to automake file.

commit 4232d1b8b1ec3d350ca8ce1d2f981d29171d2b84
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 20:16:53 2015 -0500

    Add Makefile target to build python documentation.

commit 993cade2e3a03a8c50b9f0b04a693edb5ab50bc8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 19:52:37 2015 -0500

    python-doc: correct way to reference API's.

commit fbc1fb3969eed8043ec175883f2cb5c23825a1f5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 19:22:38 2015 -0500

    Let's throw an exception when appending a sheet with an existing name.

commit 8728e84af73cecb4ffdab5545accdd849ca2efce
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 19:19:34 2015 -0500

    Forgot to add this file.

commit d71d9991c855c80ff34cf2ae9451cdb74b6f30df
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 18:00:18 2015 -0500

    python-doc: more editing.

commit 3f5eae7f0bfcaa0895a1da8b1f163a1b3c3b0efb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 17:47:54 2015 -0500

    python-doc: warn about potential perf issue with get_sheet().

commit de9f3e00016d7c5ab06f2ede6df0f2e080874cda
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 16 07:28:07 2015 -0500

    python-doc: sounds better this way.

commit a4a3e319fad108813c4739d06bf8f99527b71f10
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 23:08:04 2015 -0500

    python-doc: write doc for Document.get_sheet().

commit 8c492986b2e4a7b39c08aa7b62b562ba0fa8a8c9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 23:07:38 2015 -0500

    python: don't forget to set IndexError when no sheet object is found.

commit 8cf1ce46b7b8061f380b4351257497e98389b62b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 22:56:16 2015 -0500

    python: Document.get_sheet() to accept string argument as well.
    
    When the argument is of type string, it finds a sheet object by sheet
    name.

commit 1401156149f09e00980b0380da3a25822731027a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 22:29:04 2015 -0500

    python: add Document.get_sheet() to get sheet object by index.

commit 874316069fba43ca61de3cb3fa26dd8c74f14831
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 21:54:29 2015 -0500

    python-doc: add Document.get_sheet_names() to the doc.

commit 1af723891805e4d4fbde6055775f59b2a4f8711d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 21:49:44 2015 -0500

    python: Document.get_sheet_names() to get a tuple of sheet names.
    
    The return value can also be used to examine how many sheets are
    present in the document.

commit 845d384d98ce3bfd0f90cc565a93e0811957d00b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 17:00:39 2015 -0500

    python-doc: let's not make each method a sub section.

commit 4b7b622bf41fb0302caf2f730333f6eae4b798b3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 15 10:15:15 2015 -0500

    python-doc: add more texts to the Sheet API.

commit 685149522f680474783fbc82a45556306cbde2df
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Feb 14 21:37:24 2015 -0500

    python-doc: more editing.

commit 7068b4d5fd9d314a1f8d1329e1c226032dae89e1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Feb 14 21:05:37 2015 -0500

    python-doc: Add Document and Sheet API pages.

commit c86c8b565013ddd9e8b9919b9ccc59d27f3d247e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Feb 14 19:10:03 2015 -0500

    python: raise SheetError when dealing with detached Sheet objects.

commit f6b9e35d69dc3212dc0695b9e34aa484a0e69983
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Feb 14 17:06:54 2015 -0500

    python: more doc editing.

commit a5e4835a01b663ac4914eabb927c0b6b8ef72cd6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Feb 14 12:28:11 2015 -0500

    python: put 2 whitespaces before comment (per PEP8).

commit d063c8cced202ae50301693d7928c45bb484a02b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 13 22:27:05 2015 -0500

    python: slight wording change.

commit 18cf0558cbf11d9b6ac76f7b53c2d34fb2b6e257
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 13 22:08:48 2015 -0500

    get_string_value() should return string formula result.
    
    To be consistent with get_numeric_value() which already returns
    numeric formula result.

commit 07d7e992c25b888467fc095d6dae446d24da5317
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 13 18:07:46 2015 -0500

    python: more editing of Overview doc.

commit dfb89929bc9d51ad6ab850f5625618ebad2ff6e3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 12 22:02:34 2015 -0500

    python: put this in a Note box.

commit 2a12698f130136e4c73e6031d8866b1672f2d172
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 12 21:52:22 2015 -0500

    python: add more content to the documentation.

commit eebcae84fce0b674596d71910f3982a87484a8cd
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 12 20:49:27 2015 -0500

    More updates.

commit ca8c8fcd1b3f092d9a5f2b3e1727274487c9c90f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Feb 11 23:18:44 2015 -0500

    python: start writing some documentation.

commit 37411214938491605da289fd604cbb30e6e1fe06
Author: David Tardon <dtardon@redhat.com>
Date:   Mon Feb 9 21:17:47 2015 +0100

    update boost.m4
    
    The old one breaks on detecting boost version when used with gcc 5.

commit 2c4ba9ec2a5fba8a6e81a4c433208f15e1ec62f6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 6 21:25:29 2015 -0500

    Update the interface description to match the renaming.

commit 93fe268de59a2f95eeadf34eda344cd54b2ddf5f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 6 21:22:48 2015 -0500

    Rename the header file name to match the renamed interface name.

commit eea1a7e7ce7c35af5e282f80e11d2f268d3db426
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Feb 6 21:15:22 2015 -0500

    Rename iface::model_context to iface::formula_model_access.
    
    The interface was meant to be used only from the formula interpreter
    and its associated classes.  Let's make that explicit by renaming
    the interface name.
    
    This also resolves the confusion between the interface and its
    implementation which were both named model_context.

commit c269975f8439d892c11cfdaec8ae27666cd717da
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 5 21:54:23 2015 -0500

    ixion now requires mdds 0.12.0 (due to segment_tree API change).

commit d1488b4d778a99264418402c93440e3ff0e980f1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 5 20:55:41 2015 -0500

    python: make the test fail when wrong exception is raised.

commit 723c82559876145318a099bb16d7896b57440fbf
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Feb 5 18:58:40 2015 -0500

    python: Implement Sheet.erase_cell().

commit 0c8236b3a6415bdd29a0153106fc805821eff00c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 3 23:06:12 2015 -0500

    Next version will be 0.9.0.

commit 2afd110fbc7e617af9375f0b75e196b96392edd2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 3 23:02:23 2015 -0500

    python: Add test case for partial recalculations of formula cells.

commit f634014df02536d9e696fd00095b59ffc0b94e22
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 3 22:53:07 2015 -0500

    Remove compiler warnings.

commit ba2c6a9cd9bf1038272e05d674032e455bab5280
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 3 22:43:29 2015 -0500

    python: have Document.calculate() to do partial calculation.
    
    i.e. only calculate the ones that need to be re-calculated.

commit 0d8311fb07876607e5f0606eedf1dcdf7b9b079a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 2 23:03:30 2015 -0500

    Remove duplicate code blocks.

commit 5b8ecb5f1f97587007241812cba3d27464bcd6c6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 2 22:58:21 2015 -0500

    python: Sheet.get_numeric_value() to raise TypeError when appropriate.
    
    When trying to fetch numeric value from a formula cell when its result
    is not yet available, we should not block.  Instead we should raise
    an exception.
    
    For now TypeError is raised. But in the future we should raise our
    own exception such as ixion.FormulaError.

commit 138953f96eb5200f07af58773f86b71b40e5e9f8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Feb 2 22:17:36 2015 -0500

    Document the blocking nature of get_numeric_value().

commit 0f459cb681509923dba1b956298c302410e5ac3b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 1 12:53:11 2015 -0500

    python: add test cases for string value I/O.

commit 3783216146c09543d6c515aee0ef469518fd10b0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 1 12:47:37 2015 -0500

    Use ixion::element_type_string here.

commit 0b7d81dd189758a81653fdf0399c40bc44a93ef4
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Feb 1 12:39:32 2015 -0500

    python: use absolute path to the test file when setting sys.path.
    
    This way the script can be run anywhere independent of the current
    working directory.

commit b0f9ab52134bb3e93daeef3bc03a7c5afe6283f8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 23:23:42 2015 -0500

    python: Make sure the sheet name attribute is not writable directly.

commit d783e3f18d3374e8426ec5b7a34d434726421b6d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 23:19:40 2015 -0500

    python: add test for sheet insertions.

commit 55a942cb1bfad944c43ef0754a8fcb562dbeec1b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 23:10:00 2015 -0500

    python: add formal unit test.
    
    This gets run when running 'make check'.

commit 6b3f9ca8912f857b114474c0be0ad2d883b987b5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 19:04:28 2015 -0500

    python: implement Document.calculate(), though still a bit crude.
    
    Full calculations of all formula cells for now.

commit 2a4f1d15d01d67cb22f6c5303eb8d6ba4e88cb78
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 16:21:45 2015 -0500

    python: add skeleton for Document.calculate().

commit e6dbbe01483985d9082be558f4f23ff614cebf88
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 31 16:09:36 2015 -0500

    python: implement set_string_cell() and get_string_value().

commit 122e45d81b38c3298305cbdc31a47eddedb116a3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Jan 30 22:18:24 2015 -0500

    python: create & store formula resolver instance in a shared place.

commit f09f37ad85137af66af41fbff368c0cba51db4c6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Jan 30 20:52:53 2015 -0500

    python: implement set_formula_cell() and get_formula_expression().

commit 5a502eb15b0365d81b38d17e4a61d62db74801dd
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Jan 28 21:32:18 2015 -0500

    python: implement get_numeric_value() in Sheet class.

commit deb445c2b73fe875b1f6de034236e3ec94c343bb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Jan 28 20:52:11 2015 -0500

    python: implement set_numeric_cell() for Sheet class.

commit 4ea1af15d1274043c0e49065fec0cd3568be4f7f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jan 27 21:37:37 2015 -0500

    python: Pass model_context (pointer) to the sheet object.
    
    It will be used later to store cell values.

commit d5fd6244dd3b239610647636d77be7dcd61ea817
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jan 27 21:21:31 2015 -0500

    Move the sheet vector to document_data.

commit dbd1d2e07d47275f965a964a720733946416831c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Jan 26 22:26:27 2015 -0500

    Set up non-python part of the document storage.
    
    Use model_context there.

commit 165723f5b2dedb49aea8cd20117a525d67ebfdbe
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Jan 26 21:52:57 2015 -0500

    Append sheet instance to the document when append_sheet() is called.

commit 81e9ba542fddba134c9ddf432c9a7f50d64ba7c2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Jan 26 21:44:25 2015 -0500

    Maybe I don't have to bail out on failing tp_init.
    
    That might leak actually.

commit 9c388d392abdd6730b09dfade98b3f0d6bae8ec1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 21:52:15 2015 -0500

    python: Make Sheet.name read-only.

commit e4f498a2df1225c4ceadc6de294ac0cd5b70afa9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 19:31:42 2015 -0500

    python: Add 'name' member to 'Sheet' class.

commit 351aa18bcbe904e814072f700de1a45199996cd1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 17:56:23 2015 -0500

    Have Document.append_sheet() return an inserted sheet instance.

commit 4e7273adefaaf73b604c9b1bfd17119dfdc544cf
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 13:13:00 2015 -0500

    Add skeleton for 'Sheet' class.
    
    Still not sure how to have Document's append_sheet return a Sheet
    object...

commit bfc99bfeb5a7998521396922204d839b69a00cb6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 12:54:32 2015 -0500

    Move the 'document' code to its own source/header files.

commit 0ace22812e1a37b792ba0e16416582663186e5e6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jan 25 11:46:46 2015 -0500

    Add python.cpp to the slickedit project file.

commit 03fcf407aa857a3f7a17c343f8715a742b0bd536
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jan 24 23:18:46 2015 -0500

    Add class 'Document' placeholder to the python module.

commit f1eb785ac0fac9a01ee367211cdf09b62e37420c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Jan 23 19:29:27 2015 -0500

    ixion.info() to print the real version number string.

commit acdb47f4ea53706776425f1c5296338a229431c5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Jan 22 22:04:53 2015 -0500

    Initial hook to build ixion python module.

commit ae9d116d34ab635c1d2742f4ddfac3d54938c6e1
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Fri Jan 9 20:31:13 2015 +0100

    adapt ixion to mdds::rectangle_set change

commit e7c1189aef95f3cdd0bce7062eb45bc5500c0233
Author: Andreas Schwab <schwab@linux-m68k.org>
Date:   Fri Dec 19 20:10:28 2014 +0100

    Avoid spurious testsuite failure due to excess floating point precision
    
    Neither 0.1 nor 0.2 are exactly representable in binary floating point,
    accumulating rounding errors while summing them up.  If the sum is
    computed in excess precision it no longer compares equal to a value that
    is rounded to double precision.

commit d6d0f99c908f2282506f8ea26b94dcb13ab6e7a0
Author: Bjoern Michaelsen <bjoern.michaelsen@canonical.com>
Date:   Fri Oct 10 18:20:36 2014 +0200

    multiple build system fixes
    
    1/ automake: error: using '$(top_srcdir)' in TESTS is currently broken: '$(top_srcdir)/test/ixion-parser-test.sh'
    2/ ixion-test not finding boost symbols on linking

commit ed340d93d62310a078b4538667d58c676dc474ad
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Sep 4 17:46:51 2014 +0200

    Add test cases for more variants of table references.

commit 25fac85221431425ee2c906b4ef43948a61ec969
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Sep 4 17:45:09 2014 +0200

    Add debug output for table reference method.

commit 95618c7cd28d8d14901e30507cd732b4519527e1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Sep 4 16:11:08 2014 +0200

    Parse table reference with separator characters correctly.
    
    The key is to keep track of nest levels with [] and don't treat separator
    characters as separators when next level is > 0.

commit 3fd476fc2a7232edb6b37b6eb7ff2e39dc34dbb5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Sep 4 15:37:38 2014 +0200

    Fix printing of table token for a single argument case.

commit c9978c9db817dcdc49c27f5fc59df0b9497ce772
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 29 00:10:24 2014 -0400

    Adjust for area specifiers for single column table references.
    
    No test for this yet.  There is some parsing error that prevents this
    from working.

commit 4e5c55097d35de2c4e3de042deb2953ce639d1d9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 28 23:52:02 2014 -0400

    Correctly determine table reference range for area specifier only cases.

commit 37347f08363511bacf0c5e8462d21b0f20c86390
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 28 23:30:07 2014 -0400

    Properly print table references.

commit 16b2bf6a8acad5ffca297cd672f4b1b0f4825d69
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 28 17:39:54 2014 -0400

    Add 3 more test cases.

commit c422131c44c4d80555aaa1661d432ae04f003fa8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 28 17:30:34 2014 -0400

    More check for COUNTA.

commit 0007c0240635e96aab6b74b0c7b32b17202c3c77
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Aug 27 22:37:10 2014 -0400

    Add COUNTA built-in function.

commit 905368f182a66f5048b1e1e6e39032d63c70cdfd
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Aug 26 18:32:12 2014 -0400

    Update the table_handler interface to support column range and areas.
    
    The implementation has yet to be updated to properly support column
    ranges and area specifiers.

commit 42f79a29a97cb6fba9be8b7789b2bdad37f09e6f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 23 09:46:18 2014 -0400

    Parse column range in table reference correctly.

commit cf4baf7f1232559882a292b27e63c4e7823849f3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 23 09:26:35 2014 -0400

    Prepare for supporting column range in table references.
    
    A reference such as 'Table[[#Headers],[Col1]:[Col2]]' is valid.

commit 729fe8681bd0af9e281d90b2d01106f3250f13a2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 22 21:09:15 2014 -0400

    Table reference without a column name is valid.
    
    As long as at least one area specifier is given.

commit 59bc58094ea552f79269156e06e6acc8bc363ae6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 22 20:19:37 2014 -0400

    It's actually '#Headers' plural not '#Header' singular.

commit cabb037cbe5eca70d88cf55c2d28b273470a5f59
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 22 20:15:58 2014 -0400

    Add more test cases.

commit 72e17d5d6274be251783a27a78e16fb248718f1d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 22 20:08:41 2014 -0400

    Parse area specifier in table reference.

commit 000416f37dcdcff987709f247ad7af158ab88d04
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Aug 22 17:50:44 2014 -0400

    A table reference may specify more than one area types.
    
    Let's prepare the types for this first.

commit e765d83821c3f66e3d5792617f94c9c0859987df
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 21 23:03:12 2014 -0400

    Support resolving Table[Column] syntax.

commit 1dd658c0da9aa0971c95ec4b4a9d58ffa01e0a76
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 21 22:38:32 2014 -0400

    Parsing a table reference should be done purely based on syntax.
    
    IOW, it should not depend on whether or not the document model has
    a string identifier for the table name, column name etc.  This is to
    allow tokenization of formula expressions before registering tables
    to the document.

commit 39d92de5583b97343773729522cfaf2eae8a932a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 21 21:49:03 2014 -0400

    Actually, table_handler is not needed just to parse table references.
    
    It's needed when we need to resolve table references.

commit f5095b9b217cbb4232770be4172ded0d97841e31
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 21 21:33:13 2014 -0400

    Check the result of SUBTOTAL in this test case.

commit b1c8d303d071ed0a363f7c2dde006026a081840c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Aug 19 23:15:06 2014 -0400

    Correctly calculate SUBTOTAL for the test case.
    
    Still far from being complete.

commit 5728eaa6f3ab046e731acd637fe7fd907d6d05a0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Aug 19 09:38:14 2014 -0400

    Add table.hpp to the makefile.

commit 38257e49d548af57b81e1ccde67a037251da61fb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 18 22:05:08 2014 -0400

    Initial cut on handling table references.
    
    Still work in progress.

commit b69db21a2a6d384e44996c1d9141f94263e7065f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 14 22:02:22 2014 -0400

    Add dummy SUBTOTAL function. For now it always returns 123.

commit fd07473bf8ad0743083c4758be5c7d8c78a07027
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 14 17:58:08 2014 -0400

    Parse table column names.

commit 1953240cea371cf1a275c1e2e5ad214bdfb3b64f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Aug 13 23:04:26 2014 -0400

    Add support for defining tables. Still work in progress.
    
    I just need to work on parsing the column definitions.

commit 41eae2c6e41061d545a2e645972ad0ce87638540
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Aug 12 18:45:06 2014 -0400

    model_context impl to NOT manage the life cycles of the handlers.
    
    Let the client code manage it.

commit 234593621c568b8e25ee6017da5bd7134ab6bffc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 21:19:44 2014 -0400

    Set up skeleton table_handler implementation.

commit 92ce349c6179923ce2f51aaf1e14356dda1466b5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 21:08:17 2014 -0400

    Rename table interface to table_handler interface.
    
    To be consistent with session_handler...

commit de42e461e9722dc07cac30ec2666713a1ba8f291
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 17:40:35 2014 -0400

    Move session handler implementation out of libixion.
    
    It makes more sense to move it to ixion-parser than to leave it in
    libixion.

commit 0216e573a923cf5703cb7eddb79a650e81d26d4b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 11:21:36 2014 -0400

    Move ixion_test into src/libixion.

commit b507c4b786dd97c5f6b6d97114cc2c64bbf674bd
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 11:08:29 2014 -0400

    Hide this private method.

commit ab1dc5df50b0e4a24d22f74693b9888374cad29d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 11:02:58 2014 -0400

    Just use boost::unordered_set.

commit b4a483a760bd3fb1d4b8d2d5561b36a2903ebbc2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Aug 11 09:31:37 2014 -0400

    Use pimpl for cell_listener_tracker.

commit 7fead5cbce430f42818801360e74afb1c6a4e541
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 22:41:00 2014 -0400

    Hide depends_tracker.hpp.  This is also an implementation detail.

commit d992b1487b039a69d1edc698f32ff8765b9ca41e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 22:19:14 2014 -0400

    Remove unused header includes.

commit 7370e126fb3ca7c019d8bd285e780f002adf7b28
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 22:15:39 2014 -0400

    Update slickedit project file.

commit 0ce16e69ab8794d206a1af535dc5f46e9d795d3e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 22:14:31 2014 -0400

    Hide formula_interpreter.hpp too.

commit 50f74ea8f5243736c96face212b077131ba333e5
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 22:09:24 2014 -0400

    Hide formula_functions.hpp header.

commit e6a8545d0840b7d74fe9c7255d39272cab0df4fe
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 21:56:25 2014 -0400

    Use string_id_t to store string identifiers in all places.

commit ee82bba97ae495f1c3900574d8595e4afd44b656
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Aug 10 21:52:14 2014 -0400

    Update slickedit file.

commit b34247cf827cb124a5d0def3d51363ec06afc32f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 9 13:53:19 2014 -0400

    function_objects.hpp header is an implementation detail.  Hide it.

commit 4cd09036c37b294d5e1cf73450368111d110609b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 9 13:26:20 2014 -0400

    Make get_session_handler() a non-const method.
    
    Since it returns a non-const pointer which may point to the internal
    state of the model context.

commit a573dad918a77a6f19d7304c209d5a6796b12a9a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 9 10:30:35 2014 -0400

    Make get_session_handler() an optional virtual method.
    
    The client code doesn't need to implement this interface if it doesn't
    wish to support session_handler.
    
    And add interface.cpp which I forgot to add in the last commit.

commit db6f90f28c33dc69f443763d17dcbb370e58f187
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Aug 9 10:25:23 2014 -0400

    Hide the destructor implementations & add table interface.
    
    Table interface will be used to resolve table references.

commit 5ca89562793d8a21e1ba812e4b684c5553692060
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Jun 11 19:35:21 2014 -0400

    Support stream output of range_t and address_t.

commit d9195d86a32cd4163ff11de568b96f175416ca9c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jun 10 22:23:42 2014 -0400

    Remove 2 of the 4 variants of get_name() from formula_name_resolver.
    
    To simplify the interface a bit.

commit 2ba5cb9f2d99975bb94320f577fd7a393c482d46
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jun 10 22:16:09 2014 -0400

    Use relative A1 style for displaying cell names again.
    
    It looks better this way.

commit 18b3c9e115324c64c2061867a3c5998356e6ee0d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jun 10 22:01:29 2014 -0400

    Use multi_type_matrix to implement ixion::matrix.
    
    mixed_type_matrix has been long deprecated.

commit b868125f104a0f4f1b9809684a3ecad3f2ba58fe
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Jun 9 21:06:26 2014 -0400

    Fix built-in AVERAGE function when its has range reference as input.

commit f180104a683848ecc1d3f9488a360f7f21873370
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 23:24:32 2014 -0400

    Let's not store formula_name_resolver instance in model_context.

commit a4940d628ed75949cf04ab6d6d16befc87a81dc3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 18:56:13 2014 -0400

    Fix variable description.

commit fc4c2a18b9f4075485d549c415dc00cb84a2ce73
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 18:51:27 2014 -0400

    parser_formula_string() and print_formula_tokens() to take name resolver.
    
    To prevent each call from creating a resolver instance which is a waste
    especially when calling these functions repeatedly.

commit abcd0d478902c2c5ff82ebfc67b74bbb6dbae030
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 17:26:04 2014 -0400

    Simplify get_name() implementations of formula name resolvers.
    
    Those that take absolute address / range without anchor position should
    simply re-use the other variants that take address_t / range_t with
    anchor position.

commit e520257a2b7c2daf89d7c924e747be7b2f4a11d8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 16:37:46 2014 -0400

    Handle range reference name resolution for ODFF.

commit 8a15df406e913ede1e8469cdf7c7e023a345e26a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 13:34:36 2014 -0400

    Use to_address() for this.

commit ba1b5c76ed08859d89faec6cd476af31fe165c0d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 13:19:43 2014 -0400

    Some cleanup.

commit 3c98e9404fca7d1d949465022d7eb38c2c6fe84d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 13:03:41 2014 -0400

    Handle single cell reference in ODFF.
    
    Much of the code is a re-use of existing Excel A1 name resolver.

commit 44e854e24fc6b4f139a1af6ba2b356fef7634087
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 11:27:43 2014 -0400

    Make these methods inline, now that the whole class is hidden.

commit 8eda0889c96ccc01cc6e5b2b4f1a111bb1d541a0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Jun 8 11:21:26 2014 -0400

    Skeleton name resolver for ODFF.

commit db913b3f46ad9dd7ed63260ac4f245a9c5aca8ce
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jun 7 21:57:57 2014 -0400

    Rename test name accordingly.

commit 015a103945895ca839b2632abc90b4f644bdef9e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jun 7 21:53:25 2014 -0400

    rename formula_name_resolver_a1 -> excel_a1.
    
    Short name now that it's just a hidden implementation detail.

commit eaa52644871dce06c7baeb9000ea7e42e450f357
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jun 7 21:51:15 2014 -0400

    Hide the name resolver concrete class.

commit f8b439b96b02b6fab5867c229d93738902619a37
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jun 7 21:23:57 2014 -0400

    formula_parser to support different name resolver types.

commit 6e02d3bf03ab82bfa3adbe771eba987321840bc6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Mar 10 12:57:01 2014 -0400

    Bump the mdds version check to 0.9.0.

commit 778110a62cfc7b2b446d87d4a8efbbe3a4422e96
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Dec 13 14:40:18 2013 -0500

    Another compiler warning due to signed vs unsigned.

commit 70e2e1c13e048224885d303b4e69828cf35184df
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Dec 13 14:36:09 2013 -0500

    Remove compiler warnings.

commit 873d0fc370e4bb9e09e0e89b108bbbd0610ed929
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Dec 13 14:31:43 2013 -0500

    Forgot return statement here.

commit 0c0f2b2e528729945196d78f3ca867c4b1370d46
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Oct 15 00:32:59 2013 -0400

    Surround literal strings with double-quotes when printing formulas.

commit 2e9a863381bb0f1fa22f964fc58756bc52efdad7
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Oct 14 22:46:45 2013 -0400

    Support a way to append strings without checking for duplicates.
    
    This is needed in case of duplicate strings one of which is unformatted
    while the other has format runs. In xlsx these two are assigned different
    string ID's.

commit 53928bdab6eadb20267b1b9cf89fc4a207fba5a6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Oct 5 10:41:37 2013 -0400

    Scripts to change licenses and add modelines in source files.

commit c0571cf95a65996c4bc479dc487747014bf210de
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Oct 5 10:38:33 2013 -0400

    Update for the license change.

commit 016d252260cedbd427c3be4933443638552dd8d2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Oct 5 10:37:04 2013 -0400

    Change license from MIT to MPL 2.0.
    
    Also add emacs and vim modelines.

commit 7d8a563229aa86553db23a52e55c3d9f3b14d3b9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Jun 8 10:56:29 2013 -0400

    Adjust for recent change in mdds.

commit 8210ff5aba1a14648f195ffbcb433d2d7e04527c
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Wed May 29 10:11:26 2013 +0200

    Some cleanup of pkg-config file

commit ff2dd5fb758843a0c2dd47863c9ecb7b3de7d769
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Thu May 23 07:47:13 2013 +0200

    Ignore more files and make the *.pc file generation easier

commit a3e9bc077cd06459d4c05e02362e76afd781d466
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Wed May 22 16:10:31 2013 +0200

    Some little build-system refactoring

commit 025be4f5abf9be2b7115f8be4d24adcf332903d8
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Wed May 22 16:09:48 2013 +0200

    Try to get the ixion exports right on both windows and *nix

commit deade5700bee1ea2c3946434eb7d811404824a1b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun May 19 11:50:08 2013 -0400

    Let the caller specify sheet size on each sheet insertion.

commit 176e3e93abdac071b0b6c3ff370959f80a04225a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 14 18:20:14 2013 -0400

    Add a method that returns textural column name from numeric one.

commit 4b022a3f080a469e67afbe786c1984d6dfc362b3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 14 18:14:48 2013 -0400

    Let's remove this simple name resolver. We'll never use it.

commit 58288751c52105236171251041ddab1c7e1d1b31
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 14 18:11:20 2013 -0400

    Use callback macro and custom block func template from mdds.

commit f53d4ba5adab8b0daed47dbc6cee175ddfb91a3a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 10 19:32:19 2013 -0400

    Avoid returning a temporary.

commit 339563b43691ef12dbd1185a189e55feafd7e39d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 10 19:30:12 2013 -0400

    Export this function.

commit 9e12603ad46d5bf19b774bd88096aa80eeab6b58
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Thu May 2 17:44:19 2013 -0400

    Fix build on Windows.

commit e3e9f4cd29f68ecf1008364b48a35543bcf41829
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Apr 29 20:44:04 2013 -0400

    Specify element and element block types in ixion namespace.

commit a5933070becc6ae15ad1a2bb3cea1e4a74f3ee14
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 28 19:38:35 2013 -0400

    Up the version to make it an API incompatible change.

commit 7ac94772f287627cc332fa0c8337710543f6d3a0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 28 19:35:16 2013 -0400

    Provide a way to retrieve column from model_context.

commit cd9eb6de66be91c17ef64d4fbcced800ed285aff
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 28 19:04:33 2013 -0400

    Dedicated header for column_store_t - column storage using mdds::multi_type_vector.

commit ae2b95c9ccbc16bd90d07a9e9d164fd866818f21
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 28 17:44:12 2013 -0400

    A bit of cleanup.

commit 8d771a8cbd98fc4fabe21cf87a3f8f43bd759a5e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Apr 26 17:46:12 2013 -0400

    We need mdds here too.

commit 6b414567f22c17204e1f7e9428517d2437d5ac07
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Apr 26 14:21:12 2013 -0400

    Simplify mdds package detection, by using pkg-config.

commit 04ebfc0c72272e4bb775a1516328679507cfa130
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Mar 27 09:56:06 2013 -0400

    Fix incorrect initialization order.

commit faa6de5d792092b6018741b4a6f4f4c0097d7980
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Mar 26 13:55:59 2013 -0400

    Update boost.m4 from [ https://github.com/tsuna/boost.m4 ].

commit 2c691f65ff050c251cd5fda3a02e6884aafe8ebf
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Mar 26 13:49:48 2013 -0400

    test_PROGRAMS doesn't work for me. I get "test_dir not defined" error.

commit 1c30fa93a573460f4a0ba4c19e5ca4f1ab78c2e8
Author: Tomas Chvatal <tchvatal@suse.cz>
Date:   Tue Mar 26 18:15:12 2013 +0100

    Build test binary only for tests not for install.

commit 821cdb2f83af7d554f135e9136c0a595e2faf849
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Mar 26 10:04:36 2013 -0400

    Add this include, else the build may break.

commit 632b597b7ee4dba727a2c52d5a78050f6cbc5bf0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Mar 26 01:34:47 2013 -0400

    Fix packaging.

commit 4a81d78f71bd60535254a4dfaca8030644ebeffb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Mar 26 00:53:50 2013 -0400

    Add tar.bz2 and xz as package formats.

commit 4cdfad58f6a60b7dcf23311ee90ec1632004ee81
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 19 19:01:51 2013 -0500

    A little cleanup.

commit 64117fd4ae5beb99543e9086352a95896d2ac94c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Feb 19 18:55:07 2013 -0500

    Use position hint during cell value import to speed things up.
    
    This eliminates the lookup scalability problem, and with some documents
    speeds up the import of cell values from (too long to measure) to a few
    seconds.
    
    This change needs mdds 0.7.0 to compile.

commit f97d747eaa89d3522cce20369345e0c605b2c852
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Sun Jan 20 18:33:20 2013 +0100

    add boolean cell support

commit 061c984b4a76b8cfbfd581d9d10490079c34489f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Dec 19 14:03:51 2012 -0500

    Fix the naming inconsistency.

commit c73b834ff42202b654bc6ee60f3c5a7534b9f6fb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Dec 19 14:02:11 2012 -0500

    A little more fix here.

commit 305e67bcc01bb241242323e42e7ab99c0862cf29
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Wed Dec 19 19:37:26 2012 +0100

    this variable is only used in the DEBUG case

commit 539fcebca4e659eaf22d29d047373b023915b73a
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Wed Dec 19 19:28:10 2012 +0100

    rethrowing the same exception instead of a copy

commit 16dcdddd852ff533d0821ef98397bda72788e222
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Dec 19 13:11:38 2012 -0500

    Test for name resolver on parsing names without row indices.

commit 860926323b5f9b522bacde5e0e8bae89de5a2218
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Wed Dec 19 18:41:06 2012 +0100

    prevent to recognize [A-Z]* strings as cell address

commit f5a3a73fb0f8093cde1547f641ead9dbd799325f
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Wed Dec 19 03:29:34 2012 +0100

    output "=" for fop_equal

commit 1727fa063396fa44f49370f12355244b59440cbe
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Dec 11 19:04:29 2012 -0500

    Actually we can't use an ID of 0 for empty string. Use the max value.

commit cdcf940a9033e7f503dccd2164b9bdf1592dfe19
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Oct 6 18:16:49 2012 -0400

    Don't forget to insert an empty string.
    
    Empty string is associated with a special ID of 0 (via empty_string_id).

commit f9fa0cffb5dc198d4227471d821f312169dadd30
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Oct 2 10:42:44 2012 -0400

    Support parsing absolute column and row positions in A1 syntax.

commit 71af10432fdf7bb2cd5685ea521915fa60300ffa
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Oct 2 09:46:00 2012 -0400

    Remove duplicated code blocks.

commit d39fdfce77796389df618fbe8e77783d1938733e
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Sat Sep 29 20:31:14 2012 +0200

    support shared formual without range attached

commit 68750ae77fb4837fd1dfd1178994a9b33a7dcc7a
Author: Rene Engelhard <rene@debian.org>
Date:   Tue Sep 11 09:20:39 2012 -0400

    Another mdds header to check.

commit 5423f5bb7d15beaa3f6620aa2e5147c18699b350
Author: Markus Mohrhard <markus.mohrhard@googlemail.com>
Date:   Wed Sep 5 22:55:07 2012 +0200

    extract common parts into own Property File

commit 28a1c1f9b501d0b71b8ed24c9982c297ed65f97b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Sep 5 14:24:22 2012 -0400

    The working version for the next release will be 0.5.0.

commit 0b59ed6e8abac0a29bf874edac60a366e4143673
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 30 15:44:10 2012 -0400

    Fixed a crasher bug on Windows (32-bit).
    
    Forgot to replace this size_t with string_id_t.

commit a038588b121fb2759682980ba598e5c13087e00f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Aug 30 13:27:33 2012 -0400

    On Windows a dll file doesn't start with lib.
    
    libixion.dll -> ixion.dll.

commit 24b0dd8988f1e722e8479fb91435551c7d33954d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Aug 28 21:45:32 2012 -0400

    Get it to build again on Windows.

commit a827456bfca6242395c53f5e9956b0d4c82f5e74
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri Jul 27 16:50:14 2012 -0400

    Get ixion to build against latest mdds master.
    
    mdds no longer supports size_t as standard type. Switch to using
    unsigned long for string identifiers (for now).

commit ba55441d19f7d409de586df3e683c97879e71a1b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Jul 12 22:43:11 2012 -0400

    Renamed file.

commit bb4fc447bae13d0ab1988f2cdc153db70fff4d3e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Jul 12 22:37:29 2012 -0400

    Template function is implicitly inline.

commit 2a47ab2288f40ad9e31c794b7f57cf6cbc8874fc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu Jul 12 22:25:09 2012 -0400

    Get it to build with the latest mdds master.

commit 826f07c3d21e2215b15584844b8d899940f59476
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 26 18:25:34 2012 -0400

    Updating the years of my copyright.

commit fd244a2d3b03f328a60c07dc44ae3d4fa038343f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 26 18:13:06 2012 -0400

    Support row-only range addresses (e.g. 3:3).

commit acb05194ebba40cadb9074f747756c85230433ad
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 26 12:52:29 2012 -0400

    Another test case for multiple whole columns.

commit 2ab21889ad5d6eb4470e6c794b03a7fe048cb7b0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 26 12:51:18 2012 -0400

    More strict checking of reference address.

commit 27f7b91783428dd8ead7e9f62cf3d8cd7977c557
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 26 12:20:15 2012 -0400

    Handle ranges whose row ranges are not set (= whole columns).

commit ac67211b2732fa1d27f54e019f2d1cdb55004251
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 25 19:42:36 2012 -0400

    Use address_t to store transient parsed address value.

commit 5eab880300d0dcff04c270465c2b98287ba1992e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 25 19:28:44 2012 -0400

    Export these constants.

commit 7ef7ffde6bbb079799ad6bcefeac38d269c3f393
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 25 19:12:07 2012 -0400

    Allow range types to specify whole column or whole row.

commit 2c7838f0920734e93bd5017a97eeea3eb6e4e1f6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 24 17:46:14 2012 -0400

    Fixed build with name resolver's debug turned on, new test case.
    
    Currently we fail to parse H:H (whole column reference) correctly.

commit 1684cdd3f95a2aff9f652c24e4cf2dea43e2227e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 24 17:34:11 2012 -0400

    Fixed build with formula parser debug enabled.

commit 81a448b410e8d2a3530e6d8f48ffae0956afbc6a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 22 01:35:03 2012 -0400

    << operator should take a const reference.

commit f74e93ea5131c59094fd43dd5dd5f0ca8e14b9ea
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 15 18:12:12 2012 -0400

    These too.

commit 72224869e750593e29fbf9ba3de818a7b342d4b3
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 15 18:07:18 2012 -0400

    Use at() to access sheet and column instances.
    
    It's more STL-ish that way.

commit d17a2958072cc63c196edb7e4266ef5836d7b2c1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon May 14 19:18:27 2012 -0400

    Init model_context with no sheet, then have the client code append them.

commit 1f657727a3c514799999bf2f4bda7e39432a94af
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun May 13 20:17:05 2012 -0400

    More changes to formula cell handling and shared formula tokens.

commit 090856f4896fa013e91dd2b6b1e04aeeabd00b0a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun May 13 19:28:35 2012 -0400

    Forgot to remove this one too.

commit 955589850865b322af78ac092111b18aa3ca4ceb
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 12 17:05:29 2012 -0400

    Let's not store an empty string to the shared string pool.

commit c35d10df1ed3fa1525086cb30b65e386f95b79f7
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 12 16:46:26 2012 -0400

    Added get_string_count() to the model_context.

commit a8599ad83a25bf9fcf199f96ae6687a6e035fbac
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 12 12:31:55 2012 -0400

    Export formula_cell::get_identifier().

commit f1996b992752f1b74afb64ba7353559c517dd7f6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 12 00:52:34 2012 -0400

    Return invalid range when sheet is empty.

commit 376f89825bec2c5927db77992ee9b322d67a6ebf
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 12 00:50:03 2012 -0400

    Support invalid state in addresses and ranges.

commit 9f60cefd3eb61ba8c2bc75d7f0a926ca253a1a11
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 11 22:37:41 2012 -0400

    More test on data range.

commit 974b5eab9cd43de5304ce10e5fd64686eefe98e6
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 11 22:18:13 2012 -0400

    More test code for get_data_range(), and found&fixed a bug.

commit 0e24dab34639e617b8b53e59ecf59b9d8cc64bea
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 11 21:05:32 2012 -0400

    Hopefully better data range calculation algorithm.

commit b9c797f5c8d2886b4664a975107908a01a4e8c93
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 11 20:39:44 2012 -0400

    Some silly fixes. Let's not forget return statements.

commit 9a92828ece22f4ae0b3c3b6d3ba0ea743f4020d0
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 11 19:31:10 2012 -0400

    Implemented get_data_range() that returns data range of a sheet.

commit cacf4c1b26bfcf6ef5db39da215165ba488ecb4d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat May 5 13:25:26 2012 -0400

    Aded more methods to model_context implementation for external use.

commit 6de0e250eb06079160b3d92538c53aea6695e0ad
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 4 19:20:53 2012 -0400

    Add an empty cell type which makes code a bit simpler and more efficient.

commit 98011202b26b0e7e82999ae1fea6b3c4194a48f2
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Fri May 4 19:13:58 2012 -0400

    Renamed typedefs to make them less confusing.
    
    And wrote descriptions.

commit 30e5945de00de076de72ea1ecc133db363ea3ff9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 18:07:49 2012 -0400

    Not using boost::noncopyable reduces the size of the class by 8 bytes.

commit c94c06314a8437b6a8da3037f7a33dda68945535
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 18:04:43 2012 -0400

    More cleanup for formula_cell.

commit ec3da3e12decec8b10229cf18cec6cd64c97c430
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 17:51:42 2012 -0400

    base_cell is history.  Good riddance!

commit 54b502c23feaa09a19d13a6a1a0e9e7bca2409c8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 17:46:03 2012 -0400

    Started moving stuff from base_cell to formula_cell.

commit 0dc12178f72c92ebc8c6beaaade48d14017e7d97
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 17:33:21 2012 -0400

    Removed these callbacks for ptr_map.  I use mdds::grid_map for cell storage now.

commit 4ae6eb99e6a17460bcdfe451c48813b6ec911c00
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 17:31:22 2012 -0400

    string_cell and numeric_cell are no more.
    
    Now mdds::grid_map stores raw values directly.  No need to have those
    cell classes around.

commit 9b1b846b37c77688b975adfec3d0c0ae96a1a60e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 17:26:07 2012 -0400

    New scripts to enable gdb and valgrind runs during test.

commit 74d8a787ccb08cd4f2ace5ee9ac9e51e1f694a5e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Thu May 3 16:52:36 2012 -0400

    Added another test for model_context that currently causes segfault.

commit 4a32648cb0a26e68f5728b5bfdb0bc9ba514e5c4
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 23:23:17 2012 -0400

    Let's not access result cache directly here...

commit 5ffa2d45c6aad183d21ef4936a1b20b94f6f758d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 23:12:30 2012 -0400

    Fixed range listener code.

commit 9ae4762d2d5e9474efb4647a76f275d4d194d796
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 22:41:21 2012 -0400

    I need to check for the emptiness here as well.

commit 4ab52a661c0bedaa6850831de504b01b5825592f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 22:33:30 2012 -0400

    get_cell_name() is no more.

commit 9a655d21040d15b06394eb3d1ac76319f5e9e698
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 22:25:40 2012 -0400

    I can't query cell type on empty cell.

commit a21f7e3c292975e12f9cacb2c2947893b60e06dc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 22:03:54 2012 -0400

    I needed to keep dirty_cell_addrs_t which stores modified cells.

commit f645aba4e403c402004ea7c782176ed44868d5c7
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 21:01:06 2012 -0400

    I need to manually insert a changed cell here.

commit 4e9c899750cbbcd5a3af783f745f5177726af24c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 20:50:36 2012 -0400

    Some debugging & fixed get_numeric_value() for formula cells.

commit a35ece90e640003f57fbb06976a598d646f9093c
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 19:51:22 2012 -0400

    get_cell_position is no more.

commit e6f7a2b6ffd2eca26bb5a85213406ef0e8bb4e11
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed May 2 19:23:02 2012 -0400

    dirty_cells_t now stores abs_address_t insttead of formula_cell pointers.

commit bc9294228e2eed40a0f9941e813d29ea6b46861f
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 1 19:11:07 2012 -0400

    Let's return respective empty values when the cell type does not match.

commit 14f17e43f7ca15ff7cea8825b62b223a2869bbe8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 1 19:05:42 2012 -0400

    Adjust to changes in grid_map's method changes.

commit 19b37fbb917043f86dc416041a81e2dfcbc81bfc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 1 18:48:56 2012 -0400

    Adjusted to avoid mdds storage error.

commit 0b122e1b725c60e30a10c10d5726131ea58895ce
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue May 1 18:47:23 2012 -0400

    Added test for model context storage.

commit 75010dc7c2c0012a88d2e85033110b36c87e7b2b
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Apr 30 23:38:03 2012 -0400

    Totally switched to the new mdds::grid_map based cell storage.
    
    But tests crash everywhere.  More work ahead.

commit 8147ce6ebbf63b0d553c5417bed158325018bc66
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sun Apr 29 14:03:36 2012 -0400

    Defined cell block for formula cells.

commit 7e50569409abab879c55acbf4c5a9a091354e8a8
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Apr 28 15:46:28 2012 -0400

    Required callbacks for formula_cell_block.

commit 97cae9857fa3ab7675cc166d175437078e993cf9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Apr 28 12:26:46 2012 -0400

    Make room for the new cell storage type using mdds::grid_map.
    
    I have yet to add some customization to this new storage.

commit dea9761eadb8fdafb483e5a312c64e2a22080580
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 25 17:28:11 2012 -0400

    I don't need this forward declaration.

commit 2813b36827c3ab4d89820f9ad037781b626a9839
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 24 19:29:36 2012 -0400

    The whole private part is now in the impl class.

commit fc2a93150601e06060065e8bfe6e809762c2fddc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 24 19:12:30 2012 -0400

    Worked on moving stuff from model_context into its impl class.

commit 1e9de7ff9caf58af4b93bffca94dafef0306fb51
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 17:46:04 2012 -0400

    Cell instances, except for formula_cell, shouldn't be used outside model_context.

commit 6a600d7bcdcec1d2e1aed9ee518c23786fce9531
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 17:36:36 2012 -0400

    Use empty_string_id instead of raw value of 0.

commit 0e814ba846a6482b5c1312e0c990035991fc9689
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 01:02:39 2012 -0400

    cells_in_range is totally gone from the source tree.
    
    I won't miss it.

commit 4065c31f460549c3a09b6bdea96fd41dc091c3ea
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 00:53:14 2012 -0400

    The idea of cells_in_range was a big mistake.

commit d6e8a1f40f9175253fdd4af767b3afa199f2702e
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 00:12:36 2012 -0400

    Trying to remove external use of base_cell.

commit 4eb40415cd31c66c34bcfde3a3000eb789c518f9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 00:05:35 2012 -0400

    get_string_identifier() sounds more fit for what it does.

commit f17496d0c49178265bde1da3971fa6d4ac22d4c9
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 00:01:27 2012 -0400

    get_cell() is now gone.

commit b12e9468396815e2393599fdf4d7281ad1dbf597
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Wed Apr 11 00:00:25 2012 -0400

    Last use of get_cell() eliminated.

commit 35d482f4e93f8a9a6777947faa241a03b43bfd7d
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 23:46:48 2012 -0400

    Even less get_cell(). Almost there...

commit a1c974014c392a20f3ba586c595539b0dc9ba025
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 22:26:39 2012 -0400

    Silly typo.

commit 9a257c83802149ceab9734aaa6ee64f5eeff62ab
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 22:02:38 2012 -0400

    More on avoiding use of get_cell().

commit 7b5bddf37ba37435a61a3a0f225f69aeab65fa30
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 19:52:00 2012 -0400

    Method to get string value directly from the model.

commit e255e8ca24627e03c9f2da932fdb4441b0914935
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 19:37:33 2012 -0400

    More reduction on use of get_cell().

commit 81deb1829b8135b08fb35cc25c602b5cc3b69798
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 18:55:58 2012 -0400

    Encapsulate formula_cell retrieval.
    
    For now, we need to keep using the formula cell instances externally.

commit ee83a379b4bf5926e6701e8c5e60dfd77f3b3291
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 18:35:18 2012 -0400

    Encapsulate numeric cell value access.

commit af06df2a1edbdc8aa407e39606569dddf327a5dd
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Apr 10 18:08:38 2012 -0400

    set_cell() is no more.

commit c6c839ab664e99afee1d6b884fbc936926e741c1
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Apr 9 19:33:26 2012 -0400

    Pass raw formula strings to the model to have the model handle it internally.

commit 13fdee07c70fe16428c1522d1a9f632a264eaa11
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Apr 9 19:12:46 2012 -0400

    Pass string cell values to the model context the same way.

commit 821552de72c3ebd9b067bf1777184008746d2adc
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Mon Apr 9 19:05:19 2012 -0400

    Pass the values of numeric cells to the model instead of passing cells.
    
    First step toward limiting the use of cell objects outside the model
    context.  Eventually no cells will be used outside the model.

commit 072670db4281563d5e5f9bd5a74c0a1c7dd00b6a
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Sat Mar 10 00:05:29 2012 -0500

    Export cell_listener_tracker.

commit 79f8c20d5e5efcdf6c3803ec5741e47b71206cff
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Jan 4 19:35:02 2012 -0500

    New test case for logical functions.
    
    For now it only contains tests for IF.

commit 7abbb3d7a49f17669f88b683821ed3626449ad76
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Jan 4 19:30:19 2012 -0500

    Implemented IF function.
    
    Also added fnc_ prefix to the methods that implement built-in functions
    to avoid naming clashes with C++ keywords (such as 'if').

commit 43f31024c789036136aea31b97e2d4f4d7f43f40
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Jan 3 18:27:32 2012 -0500

    Extracted methods to make the execution flow clearer.

commit aa0f2fdab650daeda9f876b0644c6680ce8380cc
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 29 16:09:11 2011 -0500

    Basic test case for relational comparison of string values.
    
    It's far from comprehensive, but it's a start.

commit dc697a52be0e00118de74b7d4fe3df5730399fda
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 29 15:52:32 2011 -0500

    Fixed an error in test script.

commit a6752b14381199651fef75437d0b670542332d00
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 29 15:43:48 2011 -0500

    Relational comparisons with strings & test with referenced numbers.

commit 2778940d884a3bce06c77167158d620009e97485
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 19:37:45 2011 -0500

    Getting ready for mixed type relational comparison support.

commit d680f97697049632249d5fdd72a95ad7fbeaef7f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 19:32:33 2011 -0500

    Removed excessive debug statements.

commit ebf6ca556e64c53211b35d31673db88662d75bb0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 19:12:20 2011 -0500

    Some debugging attempt.

commit 979b7c5d3f48faa497621ff3b8ffc115e7a6b950
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 14:12:12 2011 -0500

    Support not equal "<>" operator.

commit 6b00140ecddaed120cf6047bc96be814e2461649
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 13:59:41 2011 -0500

    Interpret less equal and greater equal operators correctly.

commit 1109cf4dd17aeee5f59f8941a080b4f628b03484
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 28 13:41:49 2011 -0500

    Abstract away iteration steps.

commit 6ca6546f264c10ac91f9fe7b023769a94eab57c5
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 22 17:38:36 2011 -0500

    Added formula tokens for less and greater equals.
    
    The test case still fails, however. I still need to adjust the parser
    to correctly translate the lexer tokens.

commit 28cd70e8d31fa5c1d09dc7e5dc8f9f10a7802da0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 22 17:30:07 2011 -0500

    Removed duplication.

commit a593530a475a19f34dbf9a86376dc9ddeb6ccb46
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 21 19:28:31 2011 -0500

    Added less '<' and greater '>' operators.

commit eecbdaf6a6a56c5b4ebeeca4146ba69c0db08997
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 21 19:19:05 2011 -0500

    A little cleanup.

commit ed440626fc76005f6a9984443b3de31bf9f2cfb6
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 21 19:06:34 2011 -0500

    Correctly interpret equal operator. New test case for relational operators.

commit ec859df573e770d22b32c57bb606ba126d7a0c16
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Dec 20 18:45:23 2011 -0500

    Throw an error when not all tokens get interpreted.

commit 8ef98f2b4182a9dbbbe19510cba75a1b18d9f7cc
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Dec 20 18:31:52 2011 -0500

    Added equal operator to the lexer.

commit 76b611e23cba95b51fcbb02a17a4b191ef0d71b5
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Dec 17 19:37:41 2011 -0500

    Format fix.

commit f28e25890e5588379f439ce15307875f3b86d59d
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Dec 16 19:23:06 2011 -0500

    Test the delta value between two invocations of NOW().

commit 631bdcdb6c72a8ab8b9264baf2a15c14e6c2ef54
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 15 17:49:58 2011 -0500

    Add test code for volatile cell re-calculation.
    
    However, the volatile cell is not being recalculated since the cached
    formula result is not cleared.

commit aaf443ee18f598314e001a7ef556f3211dbe903d
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 15 17:15:00 2011 -0500

    Always append volatile cells to the list of dirty cells.

commit 5d58bfab49f0e23fbbbab38340adbc17d17e2d4c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 14 20:21:17 2011 -0500

    Keep track of volatile cells.

commit ed8b86536de475eb7267030a03c9a96751d020b5
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 14 19:32:07 2011 -0500

    Unregister existing formula cell before setting a new one into the model.
    
    And let's not implicitly unregister when registering.  that's wasteful.

commit fb5e711c161c6cad7d5d473642f3b6b73eae7376
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 14 19:28:39 2011 -0500

    Added NOW() built-in function.  But it only returns useless value at the moment.

commit 5e8912dddbab27c1a75556fa31fe8b128262b4b1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 14 19:04:18 2011 -0500

    Added function that checks volatility of function.
    
    For now it always returns false.

commit 583e65f144fd3614e9c3783c5e6225034db0f673
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 8 17:15:54 2011 -0500

    Test the formula calculation flow using the public API.
    
    Test for volatile functions will be added after I implement it.

commit 19f362bf921dedeff960a7ca853d5dca2a72bfe0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 7 19:39:14 2011 -0500

    Started writing a test code for volatile functions.  Still in progress.

commit 320a9c382f5d0bf811736548844ba6269f84331b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Dec 7 19:18:41 2011 -0500

    Public API to unregister formula cell.

commit 1ba0ee7ba0a89547d96697af0ec0e46cbd874d9e
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Dec 2 19:27:24 2011 -0500

    More appropriate test name.

commit 219eb0a805f9fc3cb33cb9486829ecee24128c35
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Dec 1 17:55:49 2011 -0500

    Added CONCATENATE built-in function.
    
    Unfortunately this forced me to use non-const model_context instance
    all over the interpreter, since that function may add a new string
    to the shared string table.

commit 4340b68aa2144b48c406da885e5465e1d249f2da
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Nov 29 20:14:48 2011 -0500

    Fixed a bug and check the result.

commit 06e62089652977195c3f2d873bac144a3c084aef
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Nov 29 19:53:48 2011 -0500

    pop_string() now properly supports a single cell reference.

commit d9f5e0c48a6a2c91ed229489605fd4dda41a5838
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Nov 29 18:29:23 2011 -0500

    formula_result now stores string as an identifier instead of raw string.

commit b530be3c8ddec5b1018640157e73e01746c13a12
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Nov 23 12:54:15 2011 -0500

    More on pop_string().
    
    I need a common method for all cell types that return a string ID.

commit 586f37ae647a943bdcd191f9f2acc3b811aebc26
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Nov 18 19:34:41 2011 -0500

    Adding a method to pop string for all stack value types.
    
    It's not complete yet...

commit b6877c13ac847cc2946d15fdc3d45f29a49892b9
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Nov 18 19:22:33 2011 -0500

    Handle numeric argument in LEN.

commit 65238e453413aa11351b1930eb1afbb218c33bde
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Nov 18 19:09:13 2011 -0500

    Added new built-in function LEN.
    
    For now it can only handle inline string argument.

commit 0f583efa0384ce48a1f7483f1fcc8dbaec54db5f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Nov 18 18:43:50 2011 -0500

    Test referencing cell that contains string & quote the string results.

commit 23a7b4e2dd42b9b3a41ec14f618963a20eb3c943
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Nov 18 18:33:12 2011 -0500

    Interpret string tokens correctly.

commit 8eea9b0a6390c6bd7293fa0800a9090b7cf812fd
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Nov 17 17:54:29 2011 -0500

    Parser inline strings into string tokens.

commit d547c7bfa9407742e77691b9413b28c18dca318b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Nov 17 17:10:58 2011 -0500

    New test case for inline string support.

commit 685238cb3a371a0d11e8b64b23f307c439e66293
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Nov 16 19:20:13 2011 -0500

    Support parsing of sheet names with space.
    
    Such sheet names must be surrounded with single quotes.

commit 46815aa04054750b35a1a01e14117261890b1028
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Nov 16 18:51:45 2011 -0500

    New macro for literal strings.

commit a640c7632fe1d084d9aa11e6dc0dab8dbc2641b8
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Nov 16 18:29:20 2011 -0500

    Make cell listener tracker a non-singleton.
    
    This allows the same client process to spawn multiple model context
    instances.

commit c0ec0fa1431b94f874be4ef461c96912a6c08a29
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Nov 15 18:39:34 2011 -0500

    Support case insensitive function name lookup.

commit 3ac9c8a12c2854b670c51da40aad234a77f9e920
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Nov 14 18:43:49 2011 -0500

    Added new test for case insensitive resolution of built-in function names.
    
    This test currently fails since ixion currently assumes all function
    names are UPPERCASE.

commit 78659697e53682761c105cab31c103d35c00a82f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Nov 14 18:31:11 2011 -0500

    Re-named to a more accurate test name.

commit af10f51599dd66ecad511e2ef7774c79ab2138e2
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Nov 10 17:31:07 2011 -0500

    More symbols to be exported.

commit a3fd37a7669ad3630f8b243b109173083d2598a3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Nov 10 17:08:01 2011 -0500

    Turn symbol visibility off by default, and avoid name clashing.

commit 8f97307c260fb0e75c70487aa059bf5f9a6445d2
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Nov 6 22:00:57 2011 -0500

    Forgot to add env.hpp to the makefile.

commit 1eb6bafaba3e829b51940b0ac9de1c2064ab7531
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Nov 6 14:52:31 2011 -0500

    Added Visual Studio solution and project files.
    
    Generated using Visual Studio 2008.

commit da20e401ff5824866c4ef997cb03d7d7f6e37404
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Nov 6 13:56:45 2011 -0500

    Exported all necessary symbols under MSVC++.
    
    ixion-parser.exe now runs under Windows.  Whoo Hoo!

commit 08513c1385fa35e4fa318f0660689dbeec8cde99
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Nov 6 01:10:35 2011 -0400

    Started exporting symbols for generated dll on windows.

commit 0ec4c85e80e8655e9da3ae277950d6bd899b607b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Nov 6 00:19:34 2011 -0400

    renamed namespace interface to iface.
    
    'interface' is a keyword with MSVC++.

commit 3e120af0f9e04fa85969d28a5b947ff84f3ac36a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Nov 5 23:56:48 2011 -0400

    Removed build error and warnings with MSVC++.

commit 17d460ccb970f97eb9214a182c3b0db77269dac0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 23:09:58 2011 -0400

    The pack script now does not run libtoolize nor autoconf etc.
    
    This will make it easier to build RPMs for multiple platforms with a
    single spec file.

commit 04ed911fc7be387753cbc3f916d692be15468231
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 23:00:04 2011 -0400

    More rpm spec tweaking.  It's in good shape now.

commit 17de54116e44b739ff951e6c3ea411eeed481f0c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 19:50:21 2011 -0400

    No need to specify standard directories.

commit 0ef9db7bf94a57cc5f97d2a6fe800ee4643a8f72
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 19:40:59 2011 -0400

    Summary should not end with a dot (per rpmlint).

commit c66034b638bcff1e832aa07d805d56e2fd3c1a9a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 19:34:13 2011 -0400

    Tweaked the rpm spec file.

commit 00b3c731f627b276d445694a43dfc1e30dd3809f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 02:10:54 2011 -0400

    More tweaks with package scripts.

commit 4c5c896809f0b1cd67ce79a3470dd97599df829c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 02:03:53 2011 -0400

    RPM script shouldn't use custom mdds path.

commit 7a190c68f43f0f4a290f72a5f32de92ca18ad581
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 02:01:19 2011 -0400

    More changes to autoconf & packaging.

commit 7df69deab81b504cc4118c9e791a5f72d4884b38
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 01:47:57 2011 -0400

    Check mdds header usability even when custom include path is given.

commit 22d35c1b8a817fd92534260bd08a750a26c1e1c6
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 01:21:29 2011 -0400

    Auto-detect system mdds headers if present.

commit 6743dfa37fcede458983980d5d35c1dfe50a9240
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 26 00:00:09 2011 -0400

    configure.ac now generates the rpm spec file.

commit d22263d99cfbdea39e84e984040e35625e5475ef
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Oct 25 23:43:32 2011 -0400

    Initial version of package script and rpm spec file.
    
    They still need work.

commit 4fdb609f3e0532deb57f326ebb5d1ffde9511645
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 20:50:15 2011 -0400

    Function description.

commit 2507e42d990faf173815b36835b76dfadc9eb470
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 19:23:06 2011 -0400

    Moved ixion-sorter code out of the libixion part.
    
    That code doesn't belong there.

commit b7915ed78333739f5497612f163fa1f43bf645ac
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 01:53:57 2011 -0400

    Wrapper for boost::interprocess::unique_ptr and use it for formula cell.

commit 79ea5f8eaf82c239f0d6eb0b63a649828e5c45b3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 01:37:21 2011 -0400

    Re-implemented shared formulas and removed unused code.

commit 64543fe3f82169afd45f77cb29270c68cdf1cb77
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 01:05:32 2011 -0400

    Simplify it a bit.

commit 6fafbed46a7ef6af7ad07dac848ac9443fa0c4aa
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 00:42:23 2011 -0400

    String cell definition now doesn't have to be quoted.
    
    This simplifies parsing of string cell definitions.

commit 4385e46c2b2217ecccd665ba157e897f8a97800b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 00:36:04 2011 -0400

    New test case for re-calculating formula cells referencing numeric cell.

commit 27aa80f1011d5d7ac72934fd32fc6fb9091e3282
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 00:25:59 2011 -0400

    Removed unused stuff.

commit fa905351f6704b812beb51aee356736ad705f368
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Oct 24 00:20:06 2011 -0400

    Fixed referencing cells not re-calculating when the referenced cell was not
    formula cell.

commit 408e49e8b1c09c104b0e1f97ade1c8d8b63d6a8d
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 18:26:46 2011 -0400

    Fixed some stuff.

commit b44cf20d769ffe04570cf72f48ae9dd0ea7b2503
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 15:22:28 2011 -0400

    Convert string number to numeric value without lexer.
    
    It's much simpler this way.

commit 59e2dcc04ee4bf5ec58d150fde653bee6bd31848
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 15:06:16 2011 -0400

    Valid name with empty definition should remove the cell.

commit 0e264d93b938e68446d8fdce8300fde44b3e6aff
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 15:03:11 2011 -0400

    Get all tests to pass.

commit ed8904a40a499bb1a610ea2ced914728dc4f867b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 14:48:44 2011 -0400

    Use unique_ptr to wrap raw pointer instance for exception safety.

commit 01130d73e778a856bc1be36bcfd0dfa9cefab0b3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 12:09:30 2011 -0400

    Reduce indentation level.

commit 451cb272bcd408cd9fe8f095fc9d38cdb32be9ae
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 12:05:11 2011 -0400

    Re-do the re-calc code using the formula API.

commit b2f5e1e249fa5a95c74010e2b3eb97ab3c3aa259
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 02:05:16 2011 -0400

    Cleanup.

commit b81719b2b2b17a11f48adcdbc3ae178ca84505c3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 02:01:34 2011 -0400

    Check results without using parse_data.

commit 44979ee3d31c4c8189673ec17d2e4686050dc59a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 01:47:00 2011 -0400

    Clean-up.

commit d908cee6672bb5f854243e73590d808c7a194f56
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 01:42:55 2011 -0400

    Use the formula API to calculate cells.

commit d266a9ba2f73b53015c668bdb85cba538f305943
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 01:39:13 2011 -0400

    Print separator before first non-formula cell is printed.

commit 4ff28e0293768a2c45976a3ee75f768a936447cd
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 01:28:36 2011 -0400

    Now I don't need to convert lexer tokens to formula tokens before calculation.

commit 55ab9a95dac3ae0bd3b9444ab5381dac912d3833
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 23 01:21:35 2011 -0400

    Re-wrote parse_init.
    
    Now, the initialization directly creates cells and puts them into
    the model context.

commit 47eefd981c2afb94bbf4ffc9457a7883eb757579
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Oct 22 20:51:20 2011 -0400

    Added model_parser.hpp to Makefile.am.

commit 84380057e1243ad79472a513d73639e2e1192ff1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Oct 21 22:20:43 2011 -0400

    const-ness.

commit 5e7103cb25eb86cc7d47cb7c9ef7f22fcd6acde4
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Oct 21 22:09:46 2011 -0400

    Use for_each to simplify the code a bit.

commit 7e4d3094f438552401fa6bdecc8998d17c18702a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Oct 21 21:46:54 2011 -0400

    Moved model_parser code out of libixion.
    
    This code does not belong to the library part of the code.

commit e2d562fe348b2720dc35ed6b7bf6749ab2c9c4d0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Oct 21 19:36:30 2011 -0400

    Better wording.

commit 571da4c1b21ffaec7fa9796dce43cc34c0902842
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Oct 21 19:34:07 2011 -0400

    Added function descriptions etc.

commit 6ee652ce1d5c0733f5c958ee870b7fd5729090f5
Author: Miklos Vajna <vmiklos@frugalware.org>
Date:   Sat Oct 15 15:13:03 2011 +0200

    Fix doxygen syntax to avoid misleading output

commit 41bbee32712519ec1bcf95330ef8df7d5b0b43b1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Oct 6 01:28:06 2011 -0400

    Use the sheet index of the cell when a sheet name is not explicitly given.

commit 811d36f2c75c24586a0a9adb7571c0efc5e5dac2
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 5 19:04:11 2011 -0400

    Ranges with sheet names.

commit 39f89a378f8af4f392913bf62a46dbae0bb0f4de
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 5 18:57:54 2011 -0400

    Test resolving sheets that are not the first sheet.

commit 35dec931593b5d19462129fb900d708c3d7b8dcf
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 5 18:49:46 2011 -0400

    Append sheet name to the reference name for real.
    
    Now all tests pass again.

commit 36240fed316a92ad1a7cb06232843242971b25fc
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Oct 5 18:33:07 2011 -0400

    Additional flag to toggle sheet names in reference names.

commit 4ec3c1c52e45e275843fa334f80646682df45842
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Oct 4 19:00:54 2011 -0400

    Handle sheet names and indices in the model_context implementation.

commit abe14ebafacff459c6352bb571be709aa06bc98e
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 2 13:58:26 2011 -0400

    Added test case for 3D references.  This currently fails.
    
    The implementation will follow.

commit 9100879779d493e5404e8db5e7d7cc31c097649f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 2 13:36:10 2011 -0400

    Removed methods from interface that are not needed from the formula parser.
    
    The formula parser / interpreter only need read-only access to the context
    model.  The only exception is access to the formula cells in order to
    update their circular dependency check flags.

commit 7e819e4d2ae4cfb4b39b94aee548859ca6588035
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Oct 2 13:16:04 2011 -0400

    I can put everything but main() in the anonymous namespace here.

commit 4e13e0856ef222b2266adba0968978cc91962deb
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 28 10:57:44 2011 +0900

    Optionally pass model_context instance to the resolver for sheet name resolution.

commit 208730f8757d43f52b86a2d33b6120a7911e91ba
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 28 09:43:23 2011 +0900

    Fixed a bug or two.

commit 2a37396c5ea7580c8a965134fcd458fa658496e0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 27 14:42:48 2011 +0900

    We don't use this constructor.  Revert this.

commit 0d1ab576e0cb71e6deabcd8c8902f422301cda51
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 27 13:56:33 2011 +0900

    Get shared formula cells to finally work.

commit 099e8d2b434edfb75ce5385581359b20b81ce326
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 27 11:40:35 2011 +0900

    Handle shared token ranges.

commit 5c9969040125aa04ad4b3053b88c042f2738b6ba
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 17:21:26 2011 +0900

    Now share the tokens for real if applicable.

commit ca3b707d2fa56cfffec8c2715d01863fb9ed9fec
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 16:28:08 2011 +0900

    Unresolved ref token is no more.

commit d9f94ea8142d4bc6b005af63d61c17a01c84a4e4
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 16:17:24 2011 +0900

    Started working on supporting shared formulas.

commit a89395ededbdf2b2f496797c4c2198a8e7cd6f22
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 13:57:36 2011 +0900

    Let's reset the cell listener tracker in the dtor of model_context.

commit 6ad5bb59d2eba6462be6d03260239f2b01aca304
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 13:53:50 2011 +0900

    Shared token bit in formula_cell.

commit c8047f090a81e5496d859f69d0f0363006380e8b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 13:49:17 2011 +0900

    Turns out that I need to reset the cell listener tracker for each file.
    
    Otherwise it causes ill-behavior when parsing multiple model files
    in one go.

commit 4974a8759d45d570358c6e7d5eeb817f5b736cca
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 11:53:43 2011 +0900

    New test case for sharing formula tokens across contiguous cells.

commit cdb8a75f32baa9c5b3002c4b6fb90d1fc4441c62
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 09:57:57 2011 +0900

    Test name resolution of single and range references.

commit 8ca750c9cf9e8caabe3f8fa2e25493b4ce35a41e
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 26 09:54:03 2011 +0900

    Print range names.

commit 5107c0cd4d9afa851f22a3dc62085ea4f76fe89a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 25 12:36:27 2011 +0900

    Removed the non-const version of get_formula_tokens().
    
    It makes no sense to have this method; once the tokens are set for
    a cell, we don't modify them.  We either add them or remove them.

commit 1cd07895e4ec2be8fba73af4d3eed326d682a60c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 25 12:22:27 2011 +0900

    Method descriptions.

commit 77067877cacf5e03e629489940c26a3c96d983bb
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 25 12:02:14 2011 +0900

    Implemented const_cells_in_range and other associated changes.

commit c90f3fa414213767967149829f97ebe184aed72b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 25 10:47:50 2011 +0900

    Throw model_context_error on errors related to model_context behaviors.

commit 8208a270606aab5ae3c30f55916c1022cb5c5a9d
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 25 10:39:46 2011 +0900

    Move common exceptions into own exceptions.hpp.

commit e76d48f4bda3b0a0cb22d840265ef5be917428c2
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 24 00:53:19 2011 -0400

    The method expects formula_cell instance. Let's make that explicit.

commit 3e1963490179ae6ce00a7eb2974023add4dba89a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 24 00:46:44 2011 -0400

    Wrong indentation.

commit c9e804ff178f07ded8987a2d00e21727e373551a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 24 00:41:56 2011 -0400

    Throw an exception on NULL formula tokens.

commit 1521c17c999ff512703d27f54a60be0611baab3b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 24 00:23:07 2011 -0400

    Moved more function objects to be used from calculate_cells() in formula.cpp.

commit 0e66e662ba2f5bed109d6d3fb3b9cbf264b5df31
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 23 23:50:15 2011 -0400

    Moved dirty_cells_t to types.hpp.

commit a4d2f28bc2b7ee750f0fd6d895949fe51a7c9936
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 23 23:24:38 2011 -0400

    Removed unused code.

commit 9b0c402cd035b481b4718df6cbdda62c9cf50916
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 23 23:13:55 2011 -0400

    We only have to track dependency between formula cells.
    
    So, let's not use base_cell but use formula_cell type directly.

commit 7b6b89d94f96b018dd2f762c7cc1bc402d99a9d1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 22 16:20:00 2011 -0400

    register_formula_cell() requires non-const model context.
    
    This is because it needs to have a list of non-const formula_cell
    pointers in the listener tracker.

commit fe0954399bd883c073380d3c86cbcf02719bf835
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 22 16:01:52 2011 -0400

    Make const where possible.

commit 6c6ec44feb038eb9a659c89290ac4570512d550d
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 22 15:54:30 2011 -0400

    Made formula_cell_listener_handler shareable.
    
    I need to use this in formula.cpp.

commit 816427340077133679cb31eb2b5b0518eaf25922
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 21 18:58:57 2011 -0400

    Moved basic typedef's to types.hpp (new header).

commit e687bffc0e65ee3f0d82ec67396ca62e88153c7c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 21 18:44:22 2011 -0400

    Store formula tokens per sheet.
    
    To prevent us from running out of the identifiers.

commit 9de988531d6cf3a13f281a896c299fa11d1682eb
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 17 11:36:47 2011 -0400

    Avoid allocating string just to parse result strings.

commit e53e89c7d073e3a7e73c99199fe372f39bf6c6a0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 16 22:02:18 2011 -0400

    Try not to create a string object just to convert it to a double.

commit cb799a9600f9a87ade33e02e52d44316f372a126
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 16 20:46:54 2011 -0400

    A little cleanup.

commit 29912f43a4a120887c6b4a07c1c69068e8863fdd
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 16 19:43:07 2011 -0400

    Done refactoring the lexer. Now no more buffer to consider.
    
    This is much easier to read & understand.

commit 6186b2a7e05f7adafa2a23a5806eebbe39a4c950
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 16 19:19:50 2011 -0400

    More on refactoring the lexer.

commit 5b4a5d753b45601de6eef2c4763dd51adfd281d3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 23:51:54 2011 -0400

    Refactored lexer code to make it more readable.

commit d6c9c5cdcb5652a1a1a31dbfb2ff83e5a34d4d78
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 22:53:47 2011 -0400

    resolve() now takes char pointer and size instead of string instance.
    
    This saves the caller from having to instantiate a string object just
    to call this method.

commit fd9a09cc1bdb3213687aec02d1b5cd7fe82556a5
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 21:28:11 2011 -0400

    Done supporting string formula result.

commit 1258cee519298483372ef5920ccd7a209e5ce798
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 18:22:09 2011 -0400

    Began working on supporting string formula result.

commit 3173d4fa091ef5eb9f667353c227c503c6ca8154
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 17:51:01 2011 -0400

    Compare string values during the chek run.

commit d600ffa871cb8b4a95a06a205986f8f40bfdf587
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 17:41:59 2011 -0400

    Use the pointer to the new string instance, not the old one.
    
    The passed const char* pointer will be invalid by the time I need
    to do the lookup.

commit 84dad21ac3f4e0ac2511c614dbc8a23824f27fa9
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 17:34:05 2011 -0400

    Store string instances with the model context for real.

commit 6b1f8d9138920480f2f3914b65feaee2df69e34c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 17:06:32 2011 -0400

    Parse string result to check string cell contents.

commit d18124b67f4e31e82a177cb98e9fb1ab15471ad8
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 16:44:02 2011 -0400

    Test file for defining string cells.

commit 55e5cc6c3c700ba96fa301d98a692aff0347461c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 01:49:05 2011 -0400

    model_cell's name can also be mem_str_buf.

commit b5eb92ab0edb87f8844dd31228a1c9c785e09587
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 01:31:57 2011 -0400

    Let's not create string instances for lexer tokens.
    
    While the raw string expression is being tokenized, there is no
    reason to create duplicate string instances.  Re-use the raw string
    expression buffer and avoid creating excess string instances.

commit a01f09c8aa53ba7edf05491f3212870bf6a3f8f4
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 01:01:25 2011 -0400

    Convert to string cells.

commit b3ed3f66e47458547569e69da118d4c65dff843c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 15 00:38:37 2011 -0400

    Parse quoted strings in the lexer.

commit 1cb5a8ba16d61ef4c7f6ba02f4509d4123c2c909
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 21:07:16 2011 -0400

    I call them numeric cells, not value cells.

commit 86e0e72fe60842aae9cc9374e7a827cf48d5b311
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 19:28:58 2011 -0400

    Extracted common code block into a method.

commit cbef0c304bfe820352ac436a648b4891d52c0de4
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 19:14:14 2011 -0400

    Adjusted output to print numeric cells to stdout.

commit bbc3661d90029e56bf0c62604d4dbdf069cd21c6
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 19:04:47 2011 -0400

    Sum up the value cells in formula.

commit 54c36f3544e0eab921ad7b8b48eaf354d5b2e93f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 18:47:32 2011 -0400

    I prefer the term "numeric cell".

commit 778de2bb1d97701449b8b41c06df0d8c7e3ed9bb
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 18:46:17 2011 -0400

    Only treat the first ':' as the separator.
    
    This interfered with range reference definitions.

commit f0acbb3ca4ff8492717ebff411a25214e6d42801
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 18:34:21 2011 -0400

    Verify results on numeric cells.

commit bd8b46901bdc6b309ff5f2c514298bdfc732e49f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 01:48:48 2011 -0400

    Convert cells containing values into numeric_cell instances.

commit eff9c0b9e8bd9dfbec6a363f625c584cb2e16db3
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 14 00:40:53 2011 -0400

    Parse value difinitions whose separator is ':' instead of '='.

commit fd4aadc3f06869ddc7f2c1c534b46f90e753fb47
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 13 18:46:19 2011 -0400

    New test file for testing value cell definitions.

commit 77c9790b442bacbaecc4b2c388bac14d7c984efe
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 13 21:30:56 2011 -0400

    Various build fixes.

commit 61aa1777be9d543e308ca33b9f6ab22e4119f7af
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 10 16:52:45 2011 -0400

    Clean up.

commit 443d9e036c7c24abc028c2725935b7fcbd1e91ac
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 10 16:34:23 2011 -0400

    Lastly, use the session handler to print circular references.
    
    This removes manual printing to stdout from formula_cell.

commit b204b98eeeffc16ce9b8cbe4547e544f605b5340
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 10 16:25:28 2011 -0400

    Print formula inrepretation runs to stdout via session handler.
    
    Thus avoiding manually printing in the formula interpreter code.

commit dba4f5ef8007de96328e9b8e2bd72a233555e094
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 10 14:16:35 2011 -0400

    Make the cell listener tracker instance a static local in the method.

commit 103f1a61420cee4ce5eddf4b85bf0998095a4527
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 10 13:54:36 2011 -0400

    Updated description of base_cell.

commit 1e8570e5ef338d2222c42a299e5a3a7e9f196356
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Fri Sep 9 20:40:49 2011 -0400

    Added session handler to encapsulate the code that writes to stdout.

commit 91c1abeab38fb113a191fbfcda17404f6dbb6dc4
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 20:27:38 2011 -0400

    Some cleanups. Trying to remove formula cell methods that take context.

commit d211b73e83c2acbc433a32efb819cb1f429f1e0c
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 20:16:41 2011 -0400

    Removed redundant method.

commit f7624eb26902ab6c7ed78a3e8b43cd9ea3f98542
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 19:58:13 2011 -0400

    Now, formula_cell stores identifier for its formula tokens.
    
    With this, the cell instance itself no longer stores the tokens but
    just an integer ID to retrieve them from the model context.  This
    will also serve as a stepping stone for the future shared formula
    work.

commit 7ee516c43ea4ea524b1c3b343a2f7433f6cc64ea
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 17:28:56 2011 -0400

    Have model context manage the life cycles of formula tokens instances.

commit a34c840b270bc75921f9a5ab3967a96e64afdb1f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 17:03:03 2011 -0400

    Disable public instantiation of cell listener tracker.
    
    It's a singleton now.

commit 2a89ec1b5f9af27b5f6a803ba6e302f65096b564
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 16:58:35 2011 -0400

    Turn cell range tracker into a singleton, and remove it from model_context.

commit 991fa7818e86453f0bd674357afd1e8ee8085384
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Sep 8 16:44:00 2011 -0400

    Have cell listener tracker use interface::model_context.
    
    Also, the interface now needs to provide access to non-const cell
    instances.

commit 12a9c3c92bc2413bfff1564821fbfec1f7c68307
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 7 19:16:39 2011 -0400

    Make the raw data member private to base_cell.

commit cf23a0a366d3b44507bb785eac90d093baeff43b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 7 19:10:59 2011 -0400

    Get the size of formula_tokens_t.

commit c0f561ce35514661026688998357dd29318e12b2
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Sep 7 18:57:04 2011 -0400

    Cell type doesn't need a full 32-bit range; use the higher 24-bits for flags.
    
    This saves 8 bytes from the size of formula_cell, by not having an extra
    boolean data member for the circular safe flag and also due to memory
    alignment.

commit db075e57293775c9eaa847b438db548511b28d7e
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Sep 6 19:11:25 2011 -0400

    Prep for squeezing in bit flags into a cell type value.

commit e182f0fff0a727f9ba7b4b90126f71cbcdf530e1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 22:58:03 2011 -0400

    Reduce scoping of a local var.

commit 4bbd127d7614b6e44f694ba1226f62cd62ad0422
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 22:47:58 2011 -0400

    Removed blank lines.

commit f470fa3e5b89d91552ea8519b87cf14aadbac8af
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 22:46:03 2011 -0400

    Prevent base_cell from being instantiated.

commit fc6ae5280a8b5be629b140a5c5ad042de0f635fc
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 22:43:13 2011 -0400

    Removed virtual-ness from the cell classes.

commit 7df87a9a2c46a38935d41f003da7c7a5957471a5
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 21:54:51 2011 -0400

    No one uses base_cell::print().

commit 4eaacf060f77e0df999e465380322b382851caa1
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 18:44:23 2011 -0400

    Cosmetics.

commit f9636f85a06c0c1c49058a8c2790afac85880828
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 18:30:20 2011 -0400

    Cell instances should not be copyable.
    
    I need to implement cloning for cells later.

commit 4513153f0d3d3889d7b8102fda2c58c42c192892
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 18:16:20 2011 -0400

    base_cell no longer stores listeners.

commit b1a0169823311d2d268ab03f1f8ec62b5daa1134
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 17:45:34 2011 -0400

    Minor build fixes when using from external code.

commit 5bfa5e6a09253cc542e54c9bb33cfc4829c0059f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 16:24:38 2011 -0400

    Put local stuff into anonymous namespace.

commit 70b5f13a814c7d36d43b01d04ea256c0829cf1be
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 14:36:22 2011 -0400

    Function description.

commit 603d70fa73d16f5dc25ee198b750928ddff33d2a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 14:34:46 2011 -0400

    Return the config instance for real.

commit d936bece4ae0ac055ecdfb36580cee37a212ee96
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 14:29:35 2011 -0400

    Added config struct to configure ixion's run-time behavior.
    
    It doesn't change any run-time behaviors as of yet.

commit 5b79232c01e79eceaf8fb5c8a82a82c7b1e9bcbe
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 14:03:13 2011 -0400

    Re-arranged parameter order.
    
    To have both functions begin with the identical set of parameters.

commit 7298301d471933d98f5b5690a15907e34b2d5c75
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 13:57:25 2011 -0400

    Use for_each instead of manual loop.

commit a0899b60b099e46e32e74e0d104f41887ad39885
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 13:48:57 2011 -0400

    Print separators and function names.
    
    These need to be configurable in the future.

commit d62e16ff6bc0a7bb1ce65991315069936af54f33
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 12:48:19 2011 -0400

    Initial work on printing formula tokens.

commit 882ad2974537c8fd3ba9ddb9b354145c5731c5ab
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 01:19:15 2011 -0400

    Now parse the lexer tokens and turn them into formula tokens.

commit deab0c44df326978bd53486d6946b11e36da5f0a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 01:01:48 2011 -0400

    Wrong header guard name.

commit bb36aa6a185a57e4a40dc5d6181a1dfa1f96b508
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 00:55:27 2011 -0400

    First, convert incoming raw formula string into lexer tokens.

commit 924314c4bc9bb1809a38e052ed21a8a881dff39a
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 00:33:24 2011 -0400

    Added skeleton method to print formula tokens.

commit 786e368c4f43d3219abfbc967645bb248579f9fa
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Mon Sep 5 00:15:36 2011 -0400

    Removed types.hpp.  It was a bad idea.

commit beb740645d738cf1bcdc813c35cc1ec53b0f180e
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 4 23:47:32 2011 -0400

    Wrapper script to run ixion-test.

commit 9a978462b9cbe8398cdaefb564bef609964c85c8
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sun Sep 4 23:46:29 2011 -0400

    New files to start adding useful functions for external apps to call.

commit 4b515a5161398b694efbf12d45f4aeb9b70e3685
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Sat Sep 3 16:03:11 2011 -0400

    Added Makefile.am files under include to correctly install headers.

commit 03221d3765ae3b305753d59a46965988ed1b0afc
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Aug 11 18:25:14 2011 -0400

    Added documentation.

commit 4a0a4c85aa101afe1ee3b621a8fb3b458a4f34a6
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Aug 11 18:02:43 2011 -0400

    More use of interface::model_context.

commit ab6d5767f3f7dcbedab50992fd25b721e188be3b
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Aug 11 17:45:27 2011 -0400

    Renamed formula_name_resolver_base to remove _base.

commit 4966ad37ed02d2216b673143e7e0b03bf69accb7
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Thu Aug 11 17:37:23 2011 -0400

    Now the entire formula interpreter uses interface::model_context.

commit bbc18027b5dc9f5b3692f5f45878d98b0acd5289
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Aug 10 19:30:42 2011 -0400

    More methods that need to be virtual.

commit 078a50e8ea9c48cc2bbc5737f037cbb32a195df0
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Wed Aug 10 19:20:12 2011 -0400

    Added two interface headers and started adopting the existing code.

commit a2b97487e23faacea808288579cf3ba10e11673f
Author: Kohei Yoshida <kohei.yoshida@suse.com>
Date:   Tue Aug 9 19:06:56 2011 -0400

    Removed standard iterator and moved to first(), next() based iterator.
    
    This is to allow abstraction of this class which I'll work on soon.

commit 78a5c4a63026d4cbc611e986c6bcef3eb5c672f6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Aug 9 18:22:31 2011 -0400

    Header description for cells_in_range.

commit 7e5b4eeb52cc464034dce1368e43e023a0a3f72e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Aug 9 18:18:50 2011 -0400

    Extracted a common code block into a method.

commit b06581b186a398a349fb3abadd5e43f9b7475d16
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 8 00:20:10 2011 -0400

    Removed friend-ness and moved data members to the bottom.

commit 22b87027d354816838ac7542d4759b809c0861bf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Aug 7 23:54:19 2011 -0400

    Changed method name.

commit 5bf7a4b55119f154f58f5bdeb6bf3a4ab8bf70e3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Aug 7 23:50:07 2011 -0400

    Added note for the future plan of model_context class.

commit 0738cba43a8c4c3a61095a22d266b87e4a6718f2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Aug 7 23:46:39 2011 -0400

    Updated the year of my copyright notices.

commit 16c88c40bbfa1a8980aa3b9cd594f737b7b41a0e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Aug 7 23:10:28 2011 -0400

    Turned off all debug statements.

commit 848b490b9b3c25b0f1a313a0a01a20721df51ebf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Aug 7 23:07:05 2011 -0400

    Implemented cells-in-range iterator and finally detected circular dependency!

commit 20113f2f13c225c8fd190f6baafda84e31e7f6ea
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Aug 6 23:38:55 2011 -0400

    This was never supposed to be checked in.

commit 918b817f1004309df4eb911e7dc1472ac5bd768d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Aug 6 23:38:04 2011 -0400

    Added skeleton for cells_in_range class.
    
    This class will allow iteratoring through non-empty cell instances
    for specified range.

commit 93f65f664b2b3ef62028e02f7af3b33f43608206
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Aug 6 21:33:23 2011 -0400

    Spit a debug message on unprocessed token types during circular reference check.

commit 1b247fd1802a8424eab7fc5b407ada780a8cf4b9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Aug 6 17:14:24 2011 -0400

    More debugging. Finally found out where I'm deadlocking.

commit e4c06c577548a284d006f41103e46225895694f6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Aug 6 16:50:50 2011 -0400

    Started debugging dependency tracker.

commit 6bf4bcd591e0dc788a400b71b4ea07296bf53da0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 19:40:46 2011 -0400

    I'm finished with this TODO item.

commit 0d38ca86caa5a4b439b857dd3084005db2130245
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 19:37:18 2011 -0400

    Started debugging again.

commit 9fbd5937e8b3d83db51c4f3b51f7b3abab973390
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 19:26:59 2011 -0400

    Oops.

commit 5392a498ddf4ec79f90274fb609b8632251f839c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 19:24:37 2011 -0400

    I'm not supposed to be using cout directly this way.

commit 0044c837c9a16aa36b052bd74f44330878254708
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 14:40:49 2011 -0400

    More debugging on range listener tracking in presence of circular references.

commit ac70129496fe924f8212787d0a1d3d670e074312
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Aug 5 11:01:26 2011 -0400

    Range listener tracker is no more. The name is cell listener tracker.

commit 4b34407cb1222e9a0ae2d219d09267f85ef34023
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Aug 4 18:10:29 2011 -0400

    More debugging statements.

commit fda8a308e4f523f7755055f92b713de7b55b7c37
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Aug 4 17:42:23 2011 -0400

    Don't check for presence of cell instance when adding or removing listeners.
    
    This fixes the failure to detect circular references when adding
    formula to empty cell(s).

commit 40bac736b437aaeb7a4b0c39fd4a351c49be3e38
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Aug 4 17:38:12 2011 -0400

    Support 'exit' command to explicitly exit the interpretation.
    
    This is useful when you only need to partially execute the model for
    debugging.

commit c172d81d56ebd94a7311741899d3740e06f8ab39
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Aug 3 19:17:59 2011 -0400

    Completely removed listeners from cell instances.

commit d88355aca824602fb1f23b3ed4e331a3ab42b2e3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Aug 3 18:48:21 2011 -0400

    Changed file names.

commit 6b6c8072189b678b6518d2d4dc62cd5c33bc4e6b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Aug 3 18:42:32 2011 -0400

    More on class name change.

commit eb59309a67c53554d0817031d79b0c3b3ddc6b13
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Aug 3 18:40:52 2011 -0400

    Renamed range_listener_tracker to cell_listener_tracker.
    
    This class now keeps track of single cell listeners as well as range
    listeners.

commit 9fa0f1e24bd4054c04941398ee750eeb45af9918
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 1 19:12:24 2011 -0400

    Added method to pick up all listeners of single cell addresses.

commit 31d234fa2d0dc7acb6e4ae98695ff64700b96df4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 1 18:46:36 2011 -0400

    Renamed methods.

commit 38de132a07a086cc74402b864f41b138cc6764a4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 1 18:38:16 2011 -0400

    Typo

commit 92b53330c8c4724aeb04bb69ce7dc10307b381c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 1 18:37:23 2011 -0400

    New methods to add and remove cell listeners.

commit efa57e6f513ce37dfb8296552114404d1569ab08
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Aug 1 18:24:24 2011 -0400

    Added new data member to store single cell listeners.

commit 2f72c05a965fa574e5ea625d8f51e84473f3a485
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 29 19:38:43 2011 -0400

    Replace debug cout with __IXION_DEBUG_OUT__.

commit 40c738fde56d6bd7559d3f0bc5b2e1786b45a6cc
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 20:40:53 2011 -0400

    Hmm. I forgot to check this change in !?

commit 0238e413af52ae78928180c6805e9a131740eaed
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 20:36:38 2011 -0400

    I didn't mean to commit this.

commit 5d7be3290738c5f26ab28c402a8158526791fec5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 18:33:28 2011 -0400

    New test for detecting circular reference of single cells during edit.
    
    The engine currently fails to detect this.

commit e106b47d845436409daa58750b4596127155f52b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 18:32:44 2011 -0400

    Stop traversing range references when the original target address is reached.

commit dffdb4013a068e65c9755ae2680b6fbcff03a8f5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 18:02:36 2011 -0400

    New test for circular range references.
    
    This currently crashes the engine.

commit a791163b40b1eb6867b16555ec5a7029f3a4a2ae
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 17:53:03 2011 -0400

    Adding more test cases for range ref tracking.

commit abee3e2dc4462a49641aca8fc175ebaabfd5e469
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 17:41:41 2011 -0400

    Perhaps a better way to avoid checking listeners of the same target twice.

commit e3216d0d23ac837e7077e7df8e2bd6004301a77d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 28 17:33:18 2011 -0400

    Remove bogus circular reference check during range listener traversing.
    
    Also, make sure we only check values of those cells that are defined
    in the run, by clearing previously held check values from the last run.

commit ca4cf332abfd3d51138efdf5303b6f7cccf70c3d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 19:27:07 2011 -0400

    This is the year 2011.

commit 90c43fc0efac581a9e36a5ac5846b939a908058d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 19:21:34 2011 -0400

    A5 has a constant value of 5.

commit fca7e4edde6e9beb10f9ea7c774dfd801e296f9f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 19:10:52 2011 -0400

    New test case for chained reference tracking.
    
    cell -> range -> cell -> range -> cell referencing.  This currently
    fails.

commit 899690d956f8f13ada972e266334fce3871ee489
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 19:00:48 2011 -0400

    Make sure to check for the boundary case.

commit 171e1e480aab8376c4a89aa1001f85f732d24e98
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 18:53:16 2011 -0400

    I got the row and column backward when searching for the range listeners!
    
    No wonder the search would turn up no hits.  Now fixed & all tests pass.

commit 51c30ab4b6aa5ab48f728e7962278b5501513fbd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 27 18:07:01 2011 -0400

    Debugging the range listener tracker...

commit f4dc801cc416e8aa3aa24d9a736f50b3ccdf78bf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 18:46:25 2011 -0400

    More debugging. Added name resolver methods for absolute refs.

commit 470762a4f7a6ba858f8f618d8c1bc4e4869c8d28
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 14:38:27 2011 -0400

    More test case for editing an existing value cell.
    
    This currently fails.

commit 676f7122cfe7b191e362d3e923ad60f4dc715fed
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 14:28:18 2011 -0400

    Account for relative addresses when generating names from addresses.

commit 949015d245fcde11570a2fa5c8eba39231648b71
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 14:17:00 2011 -0400

    Test range listener's ability to trigger recalc on value cell addition.
    
    Previously, adding a value to a cell that used to be empty didn't
    trigger a recalc because no existing cell was modified.  With the new
    way of tracking range references, this should correctly trigger a
    recalc.

commit a1b88117cfe5982381dbfdc46b8a05bfcf8da0ac
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 13:44:56 2011 -0400

    More debugging on resolving range refs & fixed relative range address storage.

commit 457ef93e751f6cfa9b6ee8c69ecad9e3871f27ea
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 12:51:31 2011 -0400

    More systematic way of producing debug outputs for range tokens.

commit bcfc8b03f0d2be6f33362da7bdd03f692b7c4e9f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 11:48:57 2011 -0400

    New test file for very simple, basic range reference tracking.

commit b156930689974f1d6a38c624619663c886c39d2a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 11:37:49 2011 -0400

    Fully implemented get_all_listeners().

commit 81e98ba8448bcb1da61fe72efbc780a63287a05c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 10:47:15 2011 -0400

    get_all_listener() should conceptually be a const function.

commit 0df90c95bf7a5ee20cbdf3f731431cc44f5a19d0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 26 10:02:10 2011 -0400

    More on range listener implementation.
    
    Partially implemented range listener query method. Not done yet.

commit 717228c2f9a6da88629ea5980ff60df0824cc5f8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 22 19:42:28 2011 -0400

    Added macro to toggle debug statements & ensure open-ended ranges.
    
    rectangle_set's ranges are open-ended; we need to ensure x1 < x2 and
    y1 < y2.

commit c0a4ca8af9044db78d76f77af4f81ef45190b59d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 21 18:34:34 2011 -0400

    Let's not forget to delete all the listener set instances in dtor.

commit ea5a266d5e0e59bdcfe6333eb448c721c4ecb5e0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 21 18:29:07 2011 -0400

    Implemented addition and removal of range listener tracker.

commit dd3fe6122679e45f200f9abd2956eafb33734fdc
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jul 21 17:21:47 2011 -0400

    Set up storage data member for range listeners.

commit 68837ca14d1fcd92f864ab25b2e992b50ea8bc58
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jul 20 23:29:52 2011 -0400

    Re-arranged formula ref handler to make use of range listeners.
    
    At this point, the dependency based on range-to-cells is broken
    temporarily because I haven't implemented the range listeners'
    methods yet.

commit f044bf4cb5f330da0f23f0c66912427682f66d6f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jul 19 19:28:41 2011 -0400

    Defined some data member types.

commit 255db4d8925e9f6d7602bcfb667ce19e0588c5be
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 8 19:10:48 2011 -0400

    Added empty skeleton for range listener tracker.  To be filled later.

commit 7a2fbc23d31858e30ac8c343d0e979386b09cd0c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 1 00:02:51 2011 -0400

    A little safeguard to test the logic.

commit 0a2b8a84c13366f4f7a2f6683de81a191f0f649a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 31 23:55:09 2011 -0400

    Push cell references to the stack, and resolve them later.
    
    We need this behavior for functions that manipulate reference addresses.

commit 3800aeccb53f35a34cd943f69079fc23817cc92c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 21:18:15 2011 -0400

    Version 0.3.0.

commit 69676ee136e0d83188e2b3434ec13cec12786859
Merge: 24f08d1 f7ada18
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 21:04:50 2011 -0400

    Merge branch 'range-ref-support'

commit f7ada189c6db529c49c1e6c00f8a742329fc36b0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 21:04:09 2011 -0400

    Added permanent test case for range reference handling.

commit 5a0d678d1823f750a029671f9682be73dbbd0f74
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 20:10:08 2011 -0400

    Handle dependency tracking with range references correctly.
    
    Now the cells should be calculated in the correct topological
    order even in presence of range references.

commit 8b6b7f375636d10d368b5f1b2a40c3b531893121
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 17:13:16 2011 -0400

    Pick up range references from formula cells.

commit f2972035fc99c153193d03cc16c1240d864dc500
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 26 17:07:27 2011 -0400

    Only debug model parser for now.

commit 9dd722efd1def07bc94a181b6862b24f4f0630f1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 19:13:21 2011 -0400

    Removed debug statement.

commit e9dd58ff09ea3329c5d5b453ee06f794cc5d9961
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 18:58:58 2011 -0400

    Fixed range value retrieval from the context.
    
    But right now this causes deadlock since range reference dependency
    is not properly tracked.  That's to be worked on later.

commit ce6264297ea14d9b73444e62fa7e7824e3b0be59
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 18:37:09 2011 -0400

    Properly implement summation of matrix value.

commit d4379cf4f252640b2093d6e85875d8b2c7082c0f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 18:19:59 2011 -0400

    Updated copyright years.

commit c27aba7c3a3e67e693ba458f807a74e7207d729d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 00:42:55 2011 -0400

    More on getting range reference to work properly during formula interpretation.

commit faa7dd15ba237d4cc11eea689d7c469316134326
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 25 00:14:44 2011 -0400

    Implemented model_context::get_range_value for real.

commit d9f50ad110a56213b766e611f0dd25629f17d145
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 23:34:11 2011 -0400

    Class description.

commit 0b2e10095d2bd42f6a020153eb5d850ccf78bc2b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 18:47:46 2011 -0400

    Added a means to get range values from the context.
    
    A range value is represented by a matrix object.

commit 57b67f002fc8ddb7cecc6c2063071cdb96e78824
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 18:22:50 2011 -0400

    Pass model_context to the value stack container.

commit 24f08d143e79b09e2d61924a0f6a19e97e777618
Author: Cédric Bosdonnat <cedric.bosdonnat.ooo@free.fr>
Date:   Tue May 24 12:05:44 2011 +0200

    Fixed automake tooling

commit 0ad33f7bc6e02c3f78483e986ce241f9445f0b42
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 11:50:23 2011 -0400

    A little cleanup in built-in functions.

commit abad946428591bda2730eb8645d9b0aa64229e0c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 10:46:59 2011 -0400

    Properly initialize the matrix storage.

commit 82fb7252a9d230b65971b0179963c5b667afc1a6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 24 10:39:58 2011 -0400

    Added new class ixion::matrix.
    
    This class will store range data, as well as in-line matrix data
    during formula interpretation.

commit 28eee36bab7b3990961899c004bd2f250eca5228
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 23 20:14:45 2011 -0400

    Cleaned up a bit.

commit 55fab8ec41cacb0aa9d01a83d1adb62df8193bb5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 23 18:50:34 2011 -0400

    Added configure switch to specify mdds header include path.

commit 5a7948b54726382a07891399d4ded7412d3875bb
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 19 18:50:12 2011 -0400

    Removing TODO comment...

commit f108d2edea1eb31a59515e60e786696d94e4dc4b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 19 17:30:52 2011 -0400

    Finally push range reference to the stack.

commit 331404a34c3c9609d4394f478b08f51164153011
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 19 17:07:29 2011 -0400

    Debug output for range references.

commit 5809a4c94337dc09d058d1425f7de11c8ee4affd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 19 16:55:17 2011 -0400

    Use push_value and pop_value of value_stack_t directly.

commit 9199537b5965cdb37ef254d3f3269a4ee7d3cd7f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 19 16:51:11 2011 -0400

    Methods to push single and range refs to the stack values.

commit 7d0fccb1530889f2e4faef312c9b46fe1e137bc8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 17 18:48:03 2011 -0400

    A bit cleaner algorithm making better use of the stack value API.

commit c2ef94c07f85ebc7f0d71c1aba0fc3ab2b821c88
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 15 00:15:45 2011 -0400

    Each function to return its result to the stack instead of return value.

commit da4f839b1c18f02575c797c70730e42d8995f8ec
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 23:43:19 2011 -0400

    value_stack_t as a separate class.
    
    To allow adding methods that handle stack values.

commit b021ea9adb89966dd7d5feecab8793fa5a8d455c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 22:22:23 2011 -0400

    factor may no longer include named expression.

commit eedecf5f26b193a79200730f0d2b7be2d5763074
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 22:09:41 2011 -0400

    Turn formula_function into a non-static class that can be instantiated.

commit 45dcee9f0e0e887b18eab4296020106eb6936687
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 22:05:12 2011 -0400

    Allow stack_value to store single and range references.

commit df8c71c7090065c1f94809804b3f943b348c3eeb
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 21:34:20 2011 -0400

    Make stack_value a class instead of a struct.
    
    Also did some other work to store references as stack values, instead
    of resolving references on the spot.  We need to keep them for functions
    such as OFFSET, which modifies reference addresses.

commit 3a64a37cdb23957c59c3558cc458b27f72b5e5dd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 20:02:29 2011 -0400

    In-line comment.

commit 63ece902b6e17864b89f0ded91cf95d5d51ebcd0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 19:58:45 2011 -0400

    Re-use value stack container for formula functions.

commit 471949e976dec29fd54f5c1d96bef8cc922253b6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 19:41:55 2011 -0400

    Moved stack value related stuff to global.

commit c576b98f7f641e639fc34d1028377491269bf42f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 17:26:44 2011 -0400

    Convert stack values to arguments all in one go.

commit ab102bf7248c8edb732f628015e621acfe6f72ff
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 14 16:51:42 2011 -0400

    Added class description.

commit a0ce6909c9d4b4cdf3738d0c9d7aa5fdd5f4b6d4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri May 13 02:30:55 2011 -0400

    Fixed syntax error.  I wonder why this ever compiled with newer gcc...

commit 98dca4fd9214fa87f11ca60b1b300b96029eb3b2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 12 21:45:56 2011 -0400

    Just make sure that we have the correct stack size at the end of interpretation.

commit 8039f56a4cd02b3aabc975a099ce8116329ed530
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 12 19:57:16 2011 -0400

    A little cleanup.

commit 655dddfc796187a22b9e35145664025f92c3fa57
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu May 12 19:38:49 2011 -0400

    Switch to using variable stack to pass value around in formula interpreter.

commit d64928c541381d36905bc2e9a816f89d7473bd6c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 11 19:12:11 2011 -0400

    Turn on debug for interpreter only.

commit a74abeb536b0d4bbea2cf823cd36811b9d28afa0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 11 18:59:35 2011 -0400

    Correctly convert range type names into range reference tokens.

commit e753b006ff26716753caf7c65357ba5c6293d3cf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 11 18:19:06 2011 -0400

    include/Makefile.in is no longer there.

commit f62b681a4a439de91dd872c98ccdaa6ea3fbe43a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 9 00:40:29 2011 -0400

    Correctly parse 2D range references.

commit b293088e9238187b0381284affd2b64c7a822b17
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 8 23:41:19 2011 -0400

    Extracted method that parses single cell address part.

commit 2b0a4b29d56b4380ab5f1feed247c50fd0d858bf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Apr 25 00:00:53 2011 -0400

    Don't forget to remove itself as the listener of its referenced cells.
    
    When editing a formula cell, the cell needs to be removed from its
    references as a listening cell prior to updating its formula tokens.

commit 484378967d79898cfc9fad3adb8c70cdd4551ec1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 24 23:27:22 2011 -0400

    Added description for the function object.

commit 8cf1f7db23ee2dc353da78f86930c5f8f0bfd3dc
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 24 23:15:11 2011 -0400

    Extracted another code block into function object with for_each.

commit b1947f22a70e499bed18dc9db76a85c3b27dbfaf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 24 12:34:26 2011 -0400

    Extracted code block that convert lexer tokens into formula tokens.

commit 2dc745561c7547f5771920d8e498cce7093c8a90
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 24 11:32:36 2011 -0400

    Added class/method descriptions.

commit 089be4845a97a96ece9564f7ac8faf1a44c24ce7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 24 10:37:12 2011 -0400

    Added absolute range and general range types.

commit 6977ddc852f91ebfdb7e7ea21c9a73aa7010f8fb
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 23 16:45:05 2011 -0400

    Removed Makefile's from the include directory.
    
    It builds fine without those makefiles.  Let's remove them.

commit 83cf4f5caf7a249118714edccb1fe293638529ec
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 23 16:33:51 2011 -0400

    Created include/ixion directory & moved header files into include/ixion.

commit 74c3801b1b1ce6347a02506fd41997e1e70127c7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 23 16:12:18 2011 -0400

    Renamed header directory from inc to include.

commit 4da04f608e2fa51b90ed455a6486fbbff341a967
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 18:58:44 2011 -0400

    Comment.

commit a51ff556970bd1698e21793ea658a0ad677e1ef4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 18:38:08 2011 -0400

    Let's support line comments.  Lines that start with '%%' are considered comments.

commit e471f1c55bbdc16e271723f85bca4fed4e44e53d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 18:12:43 2011 -0400

    Removed test that's a bit redundant.
    
    04-function-single.txt now tests all built-in functions.  Let's use
    that one.

commit 30319487a72cc72ae964643a8dea35882e41f2af
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 18:12:06 2011 -0400

    Verify the results of fractions.

commit 4c10bc4fd5e614f5272d3365e5c88bb0044ee4d4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 18:06:23 2011 -0400

    Simple test for built-in functions.

commit 3aa90ca7863ff6bd93664a6c55be48a011ce77f7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 17:23:20 2011 -0400

    Verify the result.

commit 5d3a4bd2cf2319bf12bdf050c924b2065b176a3c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 15:22:58 2011 -0400

    Check the result.

commit 942e9a1b5908fca9fd9aa473ca614762a39e77c2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 13:34:33 2011 -0400

    Use abs_address_t instead of address_t where appropriate.
    
    Some methods always expect absolute addresses.  Let's use abs_address_t
    for those.

commit d82dcb1f03fde7b7e91e9776d027ead799f9cf90
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 17 13:05:36 2011 -0400

    Added abosolute address type abs_address_t.

commit 749abd11ada204808f71ab4f72009f31fe84c7a6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Apr 11 01:10:51 2011 -0400

    Fixed class description.
    
    Class single_ref_token may store either relative or absolute address.

commit d5772294a1ffbd16fc37f28016076433aba0b4f2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Apr 11 01:01:07 2011 -0400

    Fixed circular dependency detection.

commit 8beb4961618750503a3fdafc8be4915baec31948
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Apr 11 00:33:25 2011 -0400

    Make all necessary changes to get it to work.

commit 873aa76c4eafb68ec7aa64d3ffaa238ffc3562e7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 9 15:33:45 2011 -0400

    Let's defer setting the reference position with the formula parser.
    
    We need to first parse the cell name in order to get the correct
    reference position, then pass that onto the formula parser.

commit 0014c44a509c813f0e86740f2090438b484bae62
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 9 15:16:17 2011 -0400

    address_t to carry relative/absolute flags & modified resolve().
    
    resolve() call now takes reference position in case it needs to
    calculate relative address.

commit c7de370d0b7169e48b659bb8f7d3e2af5a733b1d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 9 13:44:09 2011 -0400

    Set class descriptions to make it clear what single_ref_token should store.

commit bbbad74ae326cfec5144ed7c53164bd2af8c76d8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 9 11:44:21 2011 -0400

    Moved thread test files out.

commit 4930af983b3d6b0d36920ff60217f5b112c5aa92
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Apr 4 00:22:35 2011 -0400

    Run the parser tests as part of make check once again.

commit e0888667170e8fc2d2f0e99b35a5ca59801f4e4d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 3 23:28:30 2011 -0400

    Use formula name resolver to print cell address.
    
    This is so that even the names of empty cells can be properly printed.

commit 5d9b9f57a226c444c9bf7435e05dce8456f43fcf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 3 22:48:41 2011 -0400

    Fixed handling of listener cells during re-calculation.

commit 54c1d649be3ce67a5fb35d767a375ac28e900e80
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 2 13:12:34 2011 -0400

    Removed the old slickedit project files.

commit 6580e2f4f532656a8bad2deb5b80044cae1dbb1c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 2 12:35:53 2011 -0400

    Added wrapper script to execute development version of ixion-parser.

commit ba00e5ce199100eb8be28cdc93673b6bbdd5e22e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 31 17:57:47 2011 -0400

    Fixed re-calc.
    
    ptr_map does NOT overwrite existing value unlike std::map.  You need
    to remove existing value first.

commit 888afd8f550b4004fd1d288449fdc0b4d0f7063d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 27 21:15:00 2011 -0400

    Fixed cell name resolution during formula result check.

commit 5b08429f4577ba49e074323ee911278dfb8791af
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 20 10:56:56 2011 -0400

    Resolve function names first, over A1 cell names.

commit fdf35cca32a48450e9e473946004381f532809b7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 20 01:15:49 2011 -0400

    More test, and removed debug statements.

commit 3b379947ddd9e9914dd6121158438ff11d7c6b7e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 18:38:59 2011 -0400

    Fixed address to A1 name conversion & more test cases.

commit 3e80712491c7c45334d9fbd98fc2e0266bbca02d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 17:56:10 2011 -0400

    Set up a simple test code that gets runing during make check.
    
    Right now, I'm only testing A1 name resolution.

commit a4dea11ebd7ab3ce139512543fa17e0694d3b871
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 13:36:49 2011 -0400

    Removal of unused methods, typedef's etc.

commit ecab0f58a0275d47a468bf1c5927b7d1e8080cd0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 13:27:09 2011 -0400

    Dependency tracker now uses dirty cells instead of name to cell map.

commit 9e7c5287724e1369a6986a5ff2f5329f793960a4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 13:13:59 2011 -0400

    More on removing usage of name-to-pointer cell map.

commit e478014b5521cb5081a3efe2d111977081a157e1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 12:40:43 2011 -0400

    Fixed listener cell registration, plus some cleanup.

commit d1912a72a9bf0c84680d2f84e83159ffff773e23
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 11:48:09 2011 -0400

    More on using context to get cell names.

commit e90e515218c315a6b7ceb7f95681b760e918a896
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 11:34:28 2011 -0400

    Finally identified and fixed the cell dependency breakage.

commit 546b98207a0743be970cab4022d6639b50b1c69f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 19 11:13:34 2011 -0400

    More attempts to remove usage of global::get_cell_name().

commit 2015b3601458a0d4a1294a1a4dcfad23e2e9a510
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 14 02:54:37 2011 -0400

    Some work toward getting cell name from cell pointer via context.

commit bfc6b7ab10e8958ec89b52ef875459a6922c8b1d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 16:53:53 2011 -0400

    Print single ref tokens.

commit 83abb9fb2b9b1d2356125dd81b94668dbdc80793
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 14:05:40 2011 -0400

    Insert a single ref token for cell reference during lexer-to-formula token conversion.

commit eae9891fbe56b82762119aaaf44d753a1a8967b2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 13:56:58 2011 -0400

    Convert all formula tokens first, then pick up dependency info in another loop.

commit a7c9c480227c45efbeae71fdea2a877717a53946
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 03:32:22 2011 -0400

    Store cell listeners by cell address, not by pointer value.

commit fe09a12415a2800a9ed7dba4f4253af347287675
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 03:08:24 2011 -0400

    cell's print listener now uses the context object to resolve listener names.

commit 133d90a07635d7a75ebfa8722a66f641de3be73e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 01:58:52 2011 -0500

    Store cell instances into the context for real.

commit eec2bad92e1c38c334d1b6c5e0f5e1f4c7cb622c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 01:26:10 2011 -0500

    I tend to use foo_type naming convention for typedef in class scope.

commit 0626c47527867efb0980bca12296ed7431c41205
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 01:23:00 2011 -0500

    Correctly recognize definitions of formula cells and put them into context.
    
    I have yet to properly store cell instances into the context.

commit be0e9cf8b5f1bc147b7544a5ac6d95ff41109f4a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 13 00:14:42 2011 -0500

    parse A1-style cell reference, and store 3D cell address with cell ref token.
    
    Instead of storing a pointer to a cell instance, a cell ref token now
    stores the address of a cell, and the cell instance is looked up
    from the context.

commit d8619146748bd73f027ccb8b342cde6df8ed02a3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 01:48:36 2011 -0500

    Code cleanup.

commit e5f402786803db8a4827d8e486f3d53150ae0ec1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 01:43:07 2011 -0500

    Removed usage of pointer-to-name map from the thread manager.
    
    We now use the context to manage stuff like that; no need to carry
    around a separate cell pointer to name mapping object.

commit c06d8263d1f7f146c9a7997400d2909b4813e4bf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 01:17:11 2011 -0500

    You can pass a const reference thru boost::bind if the class is not copyable.

commit b974b065344fe88e25d6948eb781898b3b8cf92d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 00:58:46 2011 -0500

    Print named expression names during debugging of lexer conversion.

commit 307f0b0e21b19b574ae0db967666aec6e0e7a9a6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 00:46:38 2011 -0500

    Print the name of named expression for interpreter debugging.

commit 5b0363cd47a4b2ec4bc999aea5f0b9250b1694f4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 7 00:30:32 2011 -0500

    Detect circular referencing of named expressions, and throw an error.

commit 3ddde30cb18ec23ae60799ed4c14aadf286065cf
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 23:53:32 2011 -0500

    Expand named expressions before interpreting tokens.

commit 2b3d7ef82f2efef07527848bdbfe6ce8b83ab00c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 23:22:01 2011 -0500

    Make a duplicate token set for the interpreter.

commit 9222326f7379392817308fbc0b05102e9392300f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 22:51:06 2011 -0500

    This is now a requirement rather than a future wish list item...
    
    Nested interpretation of named expression won't resolve circular
    dependency of named expressions...

commit 2c7af07ee25780d4395b2f62271ab40b76c052dd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 22:43:32 2011 -0500

    Added note for the future.
    
    We should avoid nested interpretation as much as we can, since that
    may create too many recursions and at worst case stack memory
    overflow.

commit a1ae6979659e22870180c46612f8c09d42bee179
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 22:19:06 2011 -0500

    Interpret named expression recursively.

commit b088be1e8066d6bdb44b0bf63bbae06bfb8b7324
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 18:19:34 2011 -0500

    Treat each target as named expression, and pass the context object around.

commit 5a3a42b634a7154c7faf3935cafe0608b9ac9f8e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 17:29:47 2011 -0500

    Added header guard.  I somehow forgot.

commit 838f8f91c722185dc50b1d2f8714a18ca0271039
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 15:52:10 2011 -0500

    Removed unused method.

commit b6d9c910676d1b99270a2c7b0d92a45485c74c93
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 15:45:34 2011 -0500

    Renamed several names to fit their purpose better.
    
    Cells that one cell depends on are called "precedents".

commit 938ab3145a9617f7f264d73501e59b50105d6169
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 15:34:27 2011 -0500

    Added named expression container to the context, plus code comments.

commit dfd46e3ac1af5a6c6459eb047234139403ac9bf6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 14:00:42 2011 -0500

    Added model_context class (still empty) to fill it with context specific data.
    
    Also some code cleanup and commenting.

commit 558c8d5e92ffe2cabda645ae7771f9333d9f24ce
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 12:42:05 2011 -0500

    Wrote a skeleton for simple name resolver.

commit deddd7c3896bc0191de131e8e5d520a00761d3b3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 02:24:22 2011 -0500

    Added new files for formula name resolver classes.

commit bcd57843fb2dafc593267dbd47f53ed0b13d597c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 01:25:40 2011 -0500

    Avoid returning a pointer to a temorary instance.
    
    When returning const char* pointer, the pointer must point to a
    live object, not a temporary.

commit b7ab02261dc5c678c13b3cbb4959862d5a3fc376
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 00:41:19 2011 -0500

    Added workspace and project files for slickedit.

commit b53c2bdda2b1ee45f30292493fe3cf2fd8ccdf74
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 6 00:28:51 2011 -0500

    Added documentation for get_opcode_name().

commit 1fe8e3536e4bbe6e02660f64b7ccdcfc33f9747b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 5 23:58:14 2011 -0500

    In-line comments.

commit 8a465d59a0ff862b1e0ff0fdeaba9b9a877f359f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 5 23:54:18 2011 -0500

    Fixed a typo.

commit 0aacf3391bd9d2b1fbb6d5ead3af294d02c0d0f9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Nov 11 17:30:59 2010 -0500

    Removed unnecessary header includes.

commit 15a6fabd6dc5c80b417bc0f7b8baa994e964975a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Sep 29 17:32:42 2010 -0400

    Another place where I forgot to remove boost/unordered_set.hpp

commit 14d8165b40ff1efef57fc93c694496878be21da0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Sep 29 17:30:19 2010 -0400

    Forgot to remove #include <boost/unordered_set.hpp>.

commit 43da20b81263d8b085a3fd6142be97f1f482b109
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Sep 29 13:14:35 2010 -0400

    Skip boost >= 1.36 and boost::unordered check when the hash compat is ON.

commit 9c4f1b689fcb0599a695ea4b813ecd9ada8c63cc
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Sep 29 12:54:36 2010 -0400

    Added --with-hash-container-compat configure switch to use std::hash_foo.
    
    Without this switch, ixion uses boost::unordered_*.  With this switch
    it expects to find std::hash_* instead.

commit 06337dc63574268e91d28d214a34a5940347a13a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Sep 29 12:12:56 2010 -0400

    Added compatibility layer for hash containers.
    
    Define _IXION_HASH_CONTAINER_COMPAT compiler macro to use
    
      ::std::hash_map
      ::std::hash_set
    
    instead of
    
      ::boost::unordered_map
      ::boost::unordered_set

commit 76bc0d08b8b89093bb8e8ee0b4a8a4207698b716
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Sep 20 07:58:16 2010 -0400

    Some fix on const ref argument passing.
    
    Avoid unnecessary copying of string instance in constructor.
    Let's stick with const foo_type& foo instead of foo_type const& foo
    coding style.

commit 4b1926a698c4197ced16d64d000341515ab78ed8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Sep 20 07:48:27 2010 -0400

    Simple indent fix to keep it consistent with the rest of the code.

commit 8d3e01a77d081a9b3e853127a2665e6f09e4d6c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Sep 20 07:47:27 2010 -0400

    Adopted the new file structure.

commit ea95cc76d4fede584e13ab79d1233a6437994480
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Fri Sep 10 16:41:44 2010 +0200

    Added example file for the calculations tests

commit fb634c83b58da8f8d8121244daf9e34000da85e3
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Fri Sep 10 16:40:03 2010 +0200

    Added SUM function and implemented MIN and AVERAGE

commit 981c3cf518d6296275063b862cedd130fe3ebcf4
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Thu Sep 9 14:01:07 2010 +0200

    Forgot to add the makefile.mk to the distribution

commit 6d098b745a06a36cc7dbfc166b19d8fd9ba67a0e
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Thu Sep 9 13:52:28 2010 +0200

    Removed the use of -std=c++0x and switch to boost

commit 9b0b525b4e35868b9aa344eede11b5d88cb15098
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Thu Sep 9 13:49:03 2010 +0200

    Added dmake script for integration in OOo

commit c0d3bcfd532b0f2558e2964085e534bf6e19c66e
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Wed Sep 8 18:08:01 2010 +0200

    Possibility to ignore unresolved names in formula parser
    
    Added a mode to the formula parser to create an unresolved_ref_token for
    the unresolved names instead of failing. The default behaviour is the
    previous one: fail when the name isn't resolved.

commit a9c513e2eda26de6501f026fc83fe14fbb8167ac
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Tue Sep 7 16:18:11 2010 +0200

    Some packaging improvements
    
     * Changed version to 0.2.0 as this is a first release
     * Automaticaly generate ChangeLog for make dist
     * add the .pc.in file to the dist

commit c554a35fcea10e7c0365fedd7dd0999513509436
Author: Fridrich Štrba <fridrich.strba@bluewin.ch>
Date:   Tue Sep 7 15:56:12 2010 +0200

    Make libixion build as shared library on windows and make the detection of boost libraries to use the boost.m4 from http://github.com/tsuna/boost.m4/raw/master/build-aux/boost.m4

commit 067af9f41a1402e12c0170dde8b4936220f815a2
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Tue Sep 7 13:57:50 2010 +0200

    Automated the test running

commit 0c0fff479235fd37a60c2b3ab642e4b67dc6c05c
Author: Cédric Bosdonnat <cedricbosdo@openoffice.org>
Date:   Tue Sep 7 12:44:29 2010 +0200

    Extracted a library and added use of autotools

commit f98d1516ed96dce98846297b7df61614423e5c91
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 22:30:31 2010 -0400

    Code cleanup.

commit 3fb0116319c775a9e811c2bbb714d1de45b30e89
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 21:54:11 2010 -0400

    Fixed a serious bug in depth_first_search.
    
    index to cell node mapping was entirely wrong!  The fact that the
    formula cell dependency worked correctly was entirely pure luck.

commit 8433d9fe2e5cd06abe7d81490daf2ce6e8a91350
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 20:45:32 2010 -0400

    Done parsing sort input and run depth first search.
    
    The result is incorrect.  I need to look into this.

commit a82c262b3bc8c2b431b7b02ed41aaa19bd4c5f0d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 19:04:40 2010 -0400

    More work on sort input parsing.

commit 6c73ac1ddfedccce4f965394d870ecbc3a2a2459
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 16:47:51 2010 -0400

    Load file content into memory.

commit a8d09cb063f99db5e235a9cfada3ecae1eb0e93f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 16:32:45 2010 -0400

    Added skeleton for sort input parser.

commit 14288ee57a0f2a8685d3da144c266e7cc996326d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 15:29:10 2010 -0400

    Use templatized depend_set to keep track of dependencies.

commit c46b243b35a5ddf35258036907252250a210a257
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 14:18:15 2010 -0400

    Removed depth_first_search::cell_handler base class, in favor of using template's typename.

commit 1ca3fd7dd8e2831bfc5cdc6ff931b47b3da82afb
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 13:21:48 2010 -0400

    Removed code relevant to printing dot script code.

commit ce1193e301a7fe318437b4c0b28075d0a56fd21e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jul 12 13:12:43 2010 -0400

    Fully templatized depth_first_search.

commit b0445a752b41bd59ba965ddb09a2329059ea94f4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 23:31:50 2010 -0400

    Replaced all uses of base_cell with typedef'ed value_type inside depth_first_search.
    
    This is in preparation for templatizing depth_first_search.

commit 4d19f5b366cd62b4a8b48f061d2639cb4527c612
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 23:22:17 2010 -0400

    Fixed indentation.

commit ec079a9d4482a14018190114b262c72583c7b716
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 23:19:55 2010 -0400

    Let's not use const base_cell* in depth_first_search.

commit d3dbd2e210c9c4b2802e9c6f275302ddd97ad3c8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 23:07:16 2010 -0400

    More work on making depth_first_search independent of depends_tracker.

commit eee5b59f9a6d813683011493a6105a0fcfad1a83
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 22:40:26 2010 -0400

    Always use base_cell type to represent cells inside depends_tracker.

commit 48a2dfa7d982d34cc205414161fd0867bfb0b01d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 20:22:32 2010 -0400

    More on sorter.

commit 7ce5248673dbb08af9d0b46bed99241a5094246a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 19:54:29 2010 -0400

    Removed unnecessary parens from the return statements.

commit 82b05d8766c2fe6bc56370cb5f194c422cd9630e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 19:31:52 2010 -0400

    A bug in Makefile...

commit 4223307a000e06887aa7d835be33e51d626f8b4e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 18:01:28 2010 -0400

    Added ixion-sorter executable and its stub entry.

commit 51d3b363f373fb9ea7de772e081f2cc347b2e422
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jul 9 17:55:55 2010 -0400

    Renamed main.cpp to ixion_parser.cpp.

commit 68ff1f23ffd8d27572e68e59a22da25074a26257
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 21 20:04:57 2010 -0400

    Some files I used for illustration in my blog post.

commit b275e90361833ce920b1088235a635babb79ecde
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 21 14:41:25 2010 -0400

    Added graphbiz file for test case 01.

commit a952fdf4ebfbd762f321a69d152248ac4fa2a757
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 21 11:17:31 2010 -0400

    Fix a typo.

commit 532f84f8640a8a296236be55de856260cdf7a552
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 21 11:10:23 2010 -0400

    Tweaked the help text for the --thread, -t option.

commit 067287bf5dee2f72aaec25e140a2c8006614a9d4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 21 00:39:30 2010 -0400

    Put another global function into the global class space as its static method.

commit d5224c34cc98a2ef901b335073f7bef2232ff689
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 20:43:35 2010 -0400

    Better wording for dirty_cells_t.

commit a19e3f512b62c62c40e524a0298676a835d3d4d1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 20:40:35 2010 -0400

    Moved sleep() into global class space.
    
    Let's use the global class as a placeholder for all platform dependent
    calls.

commit a84fee70f8e696cdd844e6c35500b7bb66ad00ec
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 20:26:38 2010 -0400

    Moved get_current_time() into global class space.

commit 4eff75672d565ccbc2a2f259ad0ced834f918c8c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 20:20:51 2010 -0400

    Removed thread_test.cpp.  I don't need it any more.

commit 5f70c4fbef99f133da385dd502d3e47249593af0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 18:09:34 2010 -0400

    Moved the header include line.

commit 31dbacc23f8cb30248a4d06fcfa10b97a770b400
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 18:06:59 2010 -0400

    Always use boost::program_options, and remove the getopt code entirely.

commit e12126f563a39ad476bf040cf33fa2d56b4562e9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 18:02:46 2010 -0400

    Fix a build break when getopt is used.

commit 023693ec1a652a405d36d5843eff69bf47e338a6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 17:54:03 2010 -0400

    More on formatting the help output.

commit 81e6031e73d28440e4c2f2d82e3d81a5956afc84
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 17:38:36 2010 -0400

    Use boost::program_options to parse command line options.

commit 54e02d8b1887006b9e091e820e598c597ae16d8d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 01:10:49 2010 -0400

    Make it buildable on Windows, by defining WIN32.

commit 032780b7284b5acfad9a7a7df4e1e7b66dcdc1bd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 20 01:09:19 2010 -0400

    Additional re-calculation test.

commit e16fe8d751777cca43c8589be2ead35f0200aa4b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 21:08:35 2010 -0400

    Move all function objects near the top of the file.

commit ae09653ac14a7c910420ef5567940c94a80da87b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 20:32:21 2010 -0400

    Re-calculate only dirty cells.

commit 63bd7a9c970668cbf6a6408a8f5fe76659d379c5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 19:30:51 2010 -0400

    Calculate only dirty cells.

commit 75788f00bc10634b57ee30ed3672c1e39e565538
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 17:33:46 2010 -0400

    Have calc() take the list of recalc cells as an argument.

commit f6a50e6757ef956ce767987ba8bef6771f26a885
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 17:20:22 2010 -0400

    Have lexer token's print() return std::string instead of c string.

commit 909ee5cceb439866a7f465bee0dc8349ae0ae70c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 15:15:55 2010 -0400

    Register listener cells when converting lexer tokens to formula tokens.

commit 3ae1d567d0fd5bfd020631aa4e8fff4d0e43c57c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 09:50:40 2010 -0400

    Check the re-calculation results.

commit 0a8fc2da4f7cc11f33aea65bc5ad0c76b4ff4e26
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 00:22:27 2010 -0400

    Removed unused header includes.

commit 7c2f4fed209e0ac19d15ab1a97a00aadbe239c69
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Jun 18 00:18:28 2010 -0400

    Removed unused stack printer.

commit 7856bd5666fcf438540528b9b8d70bd27ce5d67d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 23:53:25 2010 -0400

    Removed parse_mode_input() function, which no longer makes sense.

commit f4e9fd855edd80afc68845c992ddcbc416cc1d3f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 23:47:32 2010 -0400

    Combined two near identical functions into one.

commit f0df9f87f51d7a2187f742d66a72cce0e756d1a1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 23:41:44 2010 -0400

    add_listener() sounds better.

commit f9f749bc329e33446c2336caab8715bbee33dfe7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 23:36:19 2010 -0400

    It's actually the base_cell that needs to keep track of listening formula cells.

commit ed02117bca6c02bc365470d486df8067c767424d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 23:14:25 2010 -0400

    Formula cells need to keep track of listening cells.

commit bd2764c6a8f1c0935f6599b8b378e7bf52e975fb
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 21:54:39 2010 -0400

    Fixed a bug in lexer.

commit 55ca6694b34c43e5abe331809774575decac2d2a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 21:33:09 2010 -0400

    Parse fractional numbers correctly.

commit 717009f03600812c29817332b7fa90a1a891eeb4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 21:11:47 2010 -0400

    Reworked lexer for efficiency.

commit 1b476e907a704be1b496253d015f21288c5fda86
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 19:35:25 2010 -0400

    Use mem_str_buf in the lexer code for efficiency.

commit 5448c756ead98a98e046e0fa7faa550ccd3ea3ef
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 18:16:58 2010 -0400

    Started working on parsing fractional numbers.  To be continued.

commit 6f4e25430f4ac36c537506e951cfc8a6af2a0991
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 18:02:10 2010 -0400

    Added appropriate commands to all test documents.

commit 48de79afa718d4edfaf73573fad6269a9ba0deb5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 17:53:11 2010 -0400

    Clear the parse data only once after switching to edit mode.

commit 8b05a4129a8c6ba79b2cab515ed70222ccfe8181
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 17:39:55 2010 -0400

    Reset global data for thread control before performing threaded calculation.
    
    Recalc failed because I forgot to reset global thread control data before
    performing recalculation.

commit 98a48fce23d56e63b62b2fc025a2973dd9f19a34
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 16:42:35 2010 -0400

    Make cell pointer name map globally accessible.

commit f07207f208758ad4e5a3f34bdb0c8342dd89fbf1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 15:15:27 2010 -0400

    Used typedef'ed name.

commit d23ee9605d01642794fe5b4da8d554f5cc8820c5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 14:34:30 2010 -0400

    A little code cleanup.

commit aeb5dc5f7d6fd8136cbd77b83340756db085f233
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 14:23:53 2010 -0400

    mode-init -> mode init, mode-result -> mode result etc.
    
    Let's make the mode command its own command and have it take one
    argument to switch modes.

commit 4ccdc9b5fe43b578fda3ce9738e2f8a47fa6f748
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 14:11:42 2010 -0400

    Dynamically create cell pointer-to-name map during calculation.

commit d67c8e63983751cb3d95337897a156eaa6e35c3c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 17 12:46:23 2010 -0400

    Refactored the calculation code to prepare for re-calc support.

commit 5b8a31c6fad59b8c449a082d7a3073ed99b3fe51
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 23:22:51 2010 -0400

    formula_result class in its own files.

commit 803e89a49b9cee94bfaa79cd097f06269f01f688
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 23:08:14 2010 -0400

    Finally verify calculation results and throw exceptions if results differ from the expected.

commit 62e6cd2d17552a617252d0c1b53c031ef8d0d44f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 21:36:37 2010 -0400

    model_parser::check() method to check formula calculation results.

commit c27c9d7475343bbfbfd2fe14d617a97f6333f00b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 21:25:05 2010 -0400

    Use formula_result to cache result instead of formula_cell::result_cache.

commit 1da88470f9ec5539606f697cc006429f43d4ae5f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 21:08:26 2010 -0400

    Fix a build break.

commit ae44d9338c175b1a786a28b61b5c510f6c84b4a7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 20:38:57 2010 -0400

    Parse error results.

commit aca608083f100b2d39621b7271e893979beb0a75
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 19:55:04 2010 -0400

    mem_str_buf in its own files.

commit 5d7a5797a908a21ed7162fce7dae2e7477b11413
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 19:36:20 2010 -0400

    More on parsing formula results.

commit c9af4839b0e7b7b625653f35274b83ffdaa83bed
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 17:22:38 2010 -0400

    Empty parse_result call, to be completed later.

commit 0b65699ce7bd3227e24640b4d7dad6ce9874cda9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 17:10:16 2010 -0400

    Add error data member to formula_result.

commit f17b00eef749b4bc5ee452f280b74fd1153e0e1e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 16:47:20 2010 -0400

    Refactored model_parser to support different parse modes.

commit 756c1afa1ab318736ac515993af0748f91c04a4d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 15:08:54 2010 -0400

    More on model parser change.

commit 497dc2d598b9d0315370ab11cb2120842c8a3665
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 14:01:46 2010 -0400

    Remove unused data member and methods.

commit 453e048c54f32ba08498a7e9ac45b41c8c2d0383
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 12:34:27 2010 -0400

    A little cleanup.

commit 1913efa01ea2bad82fde9f25d0fa1faa82e66ba9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 12:15:22 2010 -0400

    Perform full calculation during parsing of the model input file.

commit b88eda8081397f1674a3229fe7fb16609f0892c6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 16 10:02:57 2010 -0400

    Modified help output.

commit f72ccea3856ba139b90290124c292ee855ead101
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 23:14:51 2010 -0400

    More on model input parsing.
    
    Pick up commands.  When a line begins with a '%', it contains a
    command name.

commit 707360c5288a5b6825002d992066fa179025db5f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 22:05:24 2010 -0400

    More efficient parsing of model input files.
    
    Load the entire content of model input file into memory and use char
    pointer to keep track of current string buffer.  It's much faster
    this way.

commit 65a9510d373a77eb7f67bc6b451d357c86511530
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 20:29:55 2010 -0400

    Use std::string instead of vector<char>.

commit f338aef1d116f50c22418ae77655711757d35135
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 18:22:26 2010 -0400

    Moved inputparser.?pp to model_parser.?pp.

commit 22c1fbf10e15afb79eeb6416fee1f6ef165190aa
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 17:20:22 2010 -0400

    More javadoc comment etc.

commit 78ce47e041c4ce25f66ab118b7ed9f8ba820f542
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 16:45:10 2010 -0400

    Display the number of threads specified.

commit 6da385b9810fdd6a2671bd92e13c82b24c5c115d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 16:43:11 2010 -0400

    Add ability to specify number of threads at run-time.

commit 5a8e737d482c51fb189dd0742c7415bb4a3366b5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 14:07:31 2010 -0400

    is_circular_safe() should be a private method.

commit 2aff1ee49040c73e4ede494f763846fe69df9390
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 13:57:37 2010 -0400

    Javadoc comments for some methods.

commit 43b85ce5165f400bb0ef731a74ecf15ca9748c14
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 13:47:03 2010 -0400

    Fixed incorrect mutexing of the interpret() method.
    
    It was actually not locking the mutex at all during cell interpretation!

commit 1f26e5cc6c91ebed234d5e25ed757a99614530ae
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 13:36:00 2010 -0400

    New test file for testing concurrency.
    
    This file is much simpler than the 05 file.

commit e82ba1d707d672cf3f6810564d92107e105315ba
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 13:33:35 2010 -0400

    More on fixing synchronization problem.  Now the results are calculated correctly.

commit 4134714a86a95f351a37e4082dee3787df6167c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 12:20:15 2010 -0400

    Removed unused class.

commit b694205f79979b737adbf5f1f8235bb0c1f0a719
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 12:19:20 2010 -0400

    A little cleanup.

commit d647c54da6ab5921500448ac481444727f7054ef
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 12:11:34 2010 -0400

    Improved debug statement generation to make each output set atomic, and fixed one synchronization error which caused incorrect results.

commit 8cd7f407943824abd048a23f1b3f2aedc7880814
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 00:56:38 2010 -0400

    Cleaned up the output format a little to make it easier to read.

commit 322beba25b08df939c42dfed9c0188daed80f1e4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Jun 15 00:32:14 2010 -0400

    Fixed a single-thread calculation.

commit 2573b78fb633b76b4ee56ed1aa6905ca6ea1546b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 14 21:52:57 2010 -0400

    Display the number of CPUs.

commit 40eeb92a2a46820639d38d2cd074a41463164274
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 14 20:09:53 2010 -0400

    Build fix & disabled debug statements for the formula cell code.

commit f27b4950bd658a76de0b20ec0b5bacfaf62543ea
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 14 18:14:26 2010 -0400

    Interpret cells using threads for real, after circular dependencies have been detected.

commit e36752329054114deb6e341e4f4327e23fbd00ad
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 14 16:49:00 2010 -0400

    Started working on circular dependency detection in threaded mode.

commit 3802a2c3a1a0eedc14bd2249ef8f2545069891fa
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Jun 14 11:25:36 2010 -0400

    Print total duration for each test case.

commit d3dff7900d3f23817d9555874075967ce20e0c29
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 13 16:52:51 2010 -0400

    Display if the process is using threads.

commit 644317629c67a3e58ae23e7c95ebb9c683f1b886
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 13 16:42:55 2010 -0400

    -t to toggle using threads.

commit 1aa95963e23dfaf902f4ab61a01e3a0bdff4d822
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 13 12:02:47 2010 -0400

    Move all debug statements related to interpretation to a single place for atomic output for each cell.

commit 048ad29ecbea8fc623d4e08e79374f121b04340b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Jun 13 11:45:29 2010 -0400

    Fixed a build break.

commit 1dc70f42c72612d06719100324db15c519063823
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 3 22:38:28 2010 -0400

    Disable debug statements from the input parser code.

commit 9424af5e9737c601bd41ec9977d093123f8889c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 3 22:23:54 2010 -0400

    Disable debug statements from formula parser.

commit ad0ece1ec90074c88063774a4d444d6d88a05661
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 3 22:13:45 2010 -0400

    More on interpreter adjustment for threads.

commit a12c7814deb823eafaa6f440f0dd0d5d96b95936
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 3 19:30:13 2010 -0400

    Introduce --use-thread command line option to toggle use of threads at run-time.

commit 1129162b1bb695aa46a32cbace539429bf650bb4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Jun 3 19:09:47 2010 -0400

    Use cell_queue_manager to calculate cells with threads.

commit 76fd0d0017b4d007bc254cf420db0ffc42366a7f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 23:59:01 2010 -0400

    Fixed cell_queue_manager to properly call formula_cell::interpret().

commit 87bcb99a4d66e41e5aa4374c7897248d9a9cf89a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 23:41:20 2010 -0400

    Disable debug statements in formula_cell.

commit d8ffb20e2a906154f83abf3edf63609382c7b031
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 23:34:52 2010 -0400

    Extracted method for code cleanup.

commit bd48bec9bd9cc8130cbadf54658081944096f8c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 23:25:55 2010 -0400

    Synchronize formula cell calculation and result retrieval.

commit e8b0abe7ad4a04ff503b3126bb4bae11e680146b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 22:01:55 2010 -0400

    Added synchronized_data template by Andrew Williams, added formula_cell::interpret() method.

commit eb64227c6c7298b41fbf7626dcb56b85f3b50289
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 00:45:18 2010 -0400

    Hook the cell_queue_manager methods to the actual implementation calls.

commit a3ae8d368263110b206fbfd43d24b720cc49d7fd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 00:28:13 2010 -0400

    Copied the thread queue manager code from misc/thread_test.cpp, and got it to compile.

commit 6716407d3638e733e9f639b6609626ed61078561
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Jun 2 00:03:45 2010 -0400

    Added skeleton files for the new cell_queue_manager class.

commit e8a9b7910b6881dc6e382b6762c7989636fd4e60
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 31 22:54:21 2010 -0400

    Use struct to bind relevant members together, with mutex.

commit 2ea42c9ea83532e527ec6990e306cdfca63c2a2d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 31 22:17:31 2010 -0400

    Use a single enum data member to define actions, instead of using multiple boolean values.

commit a693e6b3694d30cab8db5a5161d38433b156b0a2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 26 23:43:36 2010 -0400

    Code cleanup.

commit 7c5fbab07ad0b220c30bbae0be8d76601073dbda
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 26 23:36:27 2010 -0400

    I still need to check for empty cell container inside the inner while loop.

commit 0929dd436674ac57de78946c746110ae91f0984c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 26 23:07:51 2010 -0400

    Have the worker threads register their idle status.  This method seems more robust.

commit 1312c2a10c87bd11c5fa673f4111529a3eaead16
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 25 23:22:00 2010 -0400

    Use worker threads to interpret cells.  There are still some synchronization issues.

commit 3daa85f35e703a80abf8cb72e33c2fe3a6ed9cb0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 25 21:22:55 2010 -0400

    Renamed some symbols & added javadoc.

commit 057fa090cbc4df756d66ed508f44cb8383d0337c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue May 25 01:10:41 2010 -0400

    Have the manager thread spawn worker threads of arbitrary count.

commit 57d10121638e2c8b7b7a683d94212911eab4d52a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 23 22:33:48 2010 -0400

    Main thread should wait until the queue thread becomes ready.

commit 21ddfcc76f0982569afed9ba2bea660298e30857
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 23 22:05:12 2010 -0400

    More on thread queue.

commit 897479a200312f3907fc0e53e9377918decca323
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 23 01:42:53 2010 -0400

    More on thread queue.

commit 2df52a8c37450969b9f31ae412f860bac124a057
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 22 20:39:31 2010 -0400

    Made 'make' to run the test directly.

commit 5837c82533ab626fb75858e5fb1f2cf664a53da7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 19 22:59:13 2010 -0400

    Use boost.thread instead of pthread.

commit 7a4339edb6a7e3f7ddc726c3294c03d3dac2287d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 19 20:03:02 2010 -0400

    Practice code for posix threads.

commit afc94fa8ea66bfb3b18817bda2c77804e8e61df4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 17 00:32:11 2010 -0400

    Now, interpret cells during DFS for real.

commit dc80b36e79520a574bf33310d4e64cd133b8ee50
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 17 00:24:53 2010 -0400

    Use handler to handle black cells during DFS.

commit 70afb21c76bf7042ed727cbf2ad8c81c33738703
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon May 17 00:14:55 2010 -0400

    More on topological sort rework.

commit f746a971d0f376fe20058628aaaf02537844f7b5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 16 23:27:00 2010 -0400

    Added hook for interpreting cells during topological sort.

commit 1404ad1ccfb4cb28fabd61e13a9cf4570a36d4fc
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 16 22:48:43 2010 -0400

    Added WAIT() function to test for parallel formula computation.

commit b81179725c96f7723025ecde1865ee0fe5f7d0a7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 12 21:22:10 2010 -0400

    Turned formula_result into a class with proper encapsulation of its data members.

commit b6f7c52503281636136b07191fc24dc3c4fa7c10
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 12 20:29:58 2010 -0400

    Updated comment.

commit f3111fab9f4ea0baacfb2158685d44f542113703
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed May 12 20:18:57 2010 -0400

    Added formula_result struct to store a dual-type formula result: numeric or textural.

commit f92ae45eda6e2981bd9e21937d3bb04b5203d943
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 16:35:56 2010 -0400

    Make sure to set the token position correctly after processing functions.

commit 700b14ee3c94bc0ef6ede68b4080bda16874b631
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 16:33:00 2010 -0400

    TODO comment.

commit 1a634c735e69c0eaa1b891cea6d90681b5f01f79
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 16:24:07 2010 -0400

    formula_functions::interpret() as the central point of function interpretations.

commit 1ebd25c9775bd2d90e50e014c4a78c9c82f770a3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 16:12:47 2010 -0400

    Use std::string instead of const char* to pass lexer token prinouts around.
    
    By using const char*, sometimes token printouts wouldn't get returned properly.

commit 40affcae5a35ec6e2bfce493ed2d95e3edbe43f9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 15:57:36 2010 -0400

    New files for formula function interpretations.

commit 4478bd9f407b4fc685dcc04244eaadb693764cec
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 15:57:03 2010 -0400

    New test model for function interpretation.

commit 23bcbf73e9c7605998905b600121745911c8347d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 15:56:24 2010 -0400

    Interpret functions during calculation.

commit b65ebbb2813f57f076956d94dd2dafe433731791
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun May 9 14:54:07 2010 -0400

    Pick up built-in function names and create function tokens.
    
    For now, I only check for MIN, MAX and AVERAGE function names.

commit 1d7700bb229597c3499ec695e0013e8db1118436
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:54:31 2010 -0400

    Print error message on reference error during lexer token parsing.

commit 6fb7467570b2e39004809e89d9b36581178e3609
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:49:33 2010 -0400

    Print ',' for separator tokens.

commit 8760c8cf61c7bbe9d629309e589601b908dab992
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:41:35 2010 -0400

    Check for empty tokens before interpreting.

commit 3399450bff16597b035ca5026c58284fc398f792
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:32:30 2010 -0400

    Renamed model input files to prefix them with numbers.

commit c53af55339aca777a350930a7b8811851e08db06
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:30:46 2010 -0400

    Modified cli interface to allow parsing multiple model files.

commit 1ad6df0151533ea494596fb270afc26a1580572e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:21:21 2010 -0400

    Exec name to ixion-parser, and use -O2 for compiler optimization.

commit 339b6c38701873fad06e913f337e477bc65c20af
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat May 8 17:15:21 2010 -0400

    Added slickedit workspace files.

commit a98cba5de3393c809ff0c32aa1dfca306fc8e9ad
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 29 00:01:41 2010 -0400

    Define error type for invalid expression.

commit 5502473d0bd8ad69ec45dcff051fb9ebbee8755e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 28 23:57:12 2010 -0400

    Reset values in the interpreter before each interpretation.

commit b01c4090244e4a22c3eebac6d8dded0653c1fc86
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 28 23:54:55 2010 -0400

    Handle division by zero condition, and store error condition with formula cells.

commit 3d7dbf2bd1ee2951758dfa5a9641cbb0be4a73d7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 28 23:30:36 2010 -0400

    Add cases for self-reference (illegal) and division by zero (error).

commit 73310ea07021783bc62164f9e182953fd2666f04
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 28 23:26:59 2010 -0400

    Add more example of circular dependency.

commit 29c381e387ff678f221668f6e358cf4c3e7442a2
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 27 23:48:29 2010 -0400

    Added two more cells that are not circular dependent.

commit f77aff4a0159c8a5158eb5fab0126085437d1d6b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 27 23:44:17 2010 -0400

    Detect circular dependency conditions and flag #REF! for such cases.

commit eed92606bd03e2d7bd3f562a1a346c4969109fa8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 27 23:29:57 2010 -0400

    Added test model for detecting circular dependencies.

commit d1ac9b0902f747ca8f2657082c0c6f86b703a05b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 21:55:17 2010 -0400

    Return expression immediately when the next token is neither + nor -.

commit 4abf42f3f5aca5baa5d37b9e11e942d5280ba435
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 20:36:48 2010 -0400

    Removed multiply_op() too.

commit 0b4cb9684e648371ea811330176cc5f21ec3121a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 20:32:54 2010 -0400

    Removed plus_op().

commit c4d177fbb2371e43b6521bbae89cd34f306dd822
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 14:31:03 2010 -0400

    Fixed the definition of expressions to get the order of precedence correctly.

commit 98577c3bb9c45185ed7c7f01d112f7ac6986ac86
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 12:13:14 2010 -0400

    Print cell names instead of pointers during expression parsing.

commit 4cc03283993b2d8bf21af0b08bbca872f741f584
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Apr 18 12:05:24 2010 -0400

    Moved some typedef's to global.hpp.

commit a2bc38504bdc0e2cb1b957d6dc997f3a18df7492
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 22:29:15 2010 -0400

    Store calculation results with the formula cells, and use them when referenced.

commit c101dc10e51183cd6af4e6737fb159d69d0d45b4
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 21:21:53 2010 -0400

    Removed unused data member.

commit f1bf55a1423720b52355f31bd46f4726efff8742
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 20:51:48 2010 -0400

    A little cleanup.

commit d836c03bb5de2f9c38988f5c6a1eabe2201499fe
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 20:43:21 2010 -0400

    Beautify interpreted expression.

commit 22defc6b176d4a38ecef3684e3c0d9fb8bc7ee9b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 20:37:53 2010 -0400

    Actually calculate result of expression interpretation.

commit d96ce74691d98563c9f6636852ddcd3182d9a50e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:57:16 2010 -0400

    Handle factors beginning with '+' or '-'.

commit c26b315c198852db6cfc813ac8e6c342787723c0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:18:13 2010 -0400

    Minor stuff.

commit 2c9db67f2bc78aecde1ddcae8493dd47246c8801
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:06:44 2010 -0400

    Another test case for parens.

commit f3e691e8d81466f700d23e4795733a2ca0fd8930
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:04:08 2010 -0400

    A little cleanup

commit 12a23936a37749bc343a5acaa713f6f39d1e9f27
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:03:16 2010 -0400

    Use switch instead of nested if's.

commit e49d38312d9e48dca49c48a686d484220ecea6e9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 11:01:03 2010 -0400

    Break factor() into paren(), variable() and constant().

commit a7966b0db0cc2bae664c94fd319569d763ef04c7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 10:54:05 2010 -0400

    Removed unused methods.

commit 64fb5df44887b85d450620aa080ad117281de696
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 10:52:55 2010 -0400

    Modified interpreter handler description.

commit 555c3eda08cf0f49c5efecf12c9e7c62e8ee6d43
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 10:49:52 2010 -0400

    Parse expressions containing parens.

commit 078f006cbca7f84de67229895452ac04253565d0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 10:42:03 2010 -0400

    More on parsing expressions.  I can now parse simple expressions without parens.

commit fd804e6baca5b36279c11bd08875e12b32ff0711
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 17 00:14:39 2010 -0400

    More on parsing expressions.

commit bde226a304c3c277598de6f1cade536f7f3e5fa9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Apr 16 23:57:52 2010 -0400

    More on parsing expressions.

commit 4ec53e579cd14883b446563baaae5c9780cfe9f3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Apr 16 23:39:06 2010 -0400

    Started implementing expression parser.

commit 2f0868da5bc113bbeb9c9aceac7111d3aa85cb3e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Apr 16 00:17:05 2010 -0400

    Call formula_interpreter's interpret() on each formula cell.
    
    At this point the interpret() method is still just a skeleton.

commit 46b99f92378d8e248c09b52ec71a9c19d1b3b68b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Fri Apr 16 00:03:17 2010 -0400

    Moved lexer token printing method into lexer_tokens.* files.

commit 3d975ad0a132d5aa91d923b83819c300e600d173
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 23:55:21 2010 -0400

    Remove const from base_cell* where I need to.
    
    These pointers are later used to interpret cells.  So they can't be
    const.

commit bb3711f3d1ccdfba65975989436a21b68e350c11
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 23:43:24 2010 -0400

    renamed local vars to make their role clearer.

commit d47fb58bff5d5d15d82b06ff6e79f62c6badda45
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 23:10:59 2010 -0400

    Added skeleton files for formula_interpreter.

commit 0754e12bd7be1cbfd2a1217504041e6573aea752
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 22:58:23 2010 -0400

    print sorted cells once again.

commit d18b9b6469f7e4f5eafecd9867dc0da5a4080231
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 22:50:47 2010 -0400

    blank line

commit 33e3a65ca34eeacce055f714fb87751b65255bd5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 22:43:02 2010 -0400

    Convert primitive and value tokens.

commit 55031c5c3c4ad4e7b824aa3c5874eba93d33ffd1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 22:01:27 2010 -0400

    Add opcode token to use it for the primitive token types.

commit b77d20fcf1ef721c018f69aed840e925c0da121c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 01:07:48 2010 -0400

    Finally print something in formula_parser::print_tokens().

commit 2e27782663f08bc70f6fece40d5c543e75241cc0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Apr 15 00:29:12 2010 -0400

    Call print_tokens() to print formula tokens.

commit 16975b83de19cac311d32c6aeb14fec9cdde9e25
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 22:41:21 2010 -0400

    renamed tokens.* to lexer_tokens.*

commit e92af3953590c8d05a5caabf7213e5877a20b951
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 22:38:21 2010 -0400

    renamed a bunch of lexer classes etc. to have them start with lexer_.

commit 62e934a9f6a5af92d98eb256d59aaccb0d56fe1c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 22:34:11 2010 -0400

    Add print_tokens() skeleton.

commit 0a165252649605094ea67d8d76f94b25b4f22b4e
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 22:26:29 2010 -0400

    Commented out debug prints for the dependency tracker code.
    
    I now need to focus on lexer to formula token conversion.

commit c2341d90acc54b3b63d15a47901804d818a5fb04
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 22:18:34 2010 -0400

    Use iterator for the for-loop, instead of array access.

commit 8652b9132f34f99f8e4630bc78815e477bb5da9c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Wed Apr 14 00:03:14 2010 -0400

    have topo_sort_cells() return a vector of sorted cell ptrs.

commit 5f58b17fb350b51785a9cc8b36644f621f10db10
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 23:25:48 2010 -0400

    prettify printout of sorted cells.

commit e48cd57caeb7bc87d5368f8f68f080ba1edfa3c1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 23:21:29 2010 -0400

    Make sure to process all cells, even the ones that are not formula cells.

commit 1d5a2455297ffbce4ea8ea107b5d9a25cac17365
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 23:00:18 2010 -0400

    Store topologically sorted cells.

commit 2e90a3238cf05117017bb9b4161722047d592633
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 22:55:16 2010 -0400

    a little code cleanup.

commit b9b2471d6c23f4898d2a025f1ec6d37647e57601
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 22:52:27 2010 -0400

    Add initialization to make the dfs repeatable.

commit 27a63a53e672563c356c3eb36b8af787a212442f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 22:42:26 2010 -0400

    Moved depth_first_search into its own files.

commit dc64a3f724526dd97c008f3fa87c89af435f2df0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 21:25:40 2010 -0400

    Move method definitions of depth_first_search out of its class declaration.

commit c10fd81c51f868bddd45a15efff53cefb8d0ad9c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 20:50:12 2010 -0400

    Store own cell pointer in celldata struct too.

commit 525a4a1e8e3d35845fdcc93858e1f397d3dcd7a3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 20:29:10 2010 -0400

    Use celldata struct to store metadata for each cell, instead of using separate vectors.

commit 340422a9447be3e7ffc6d50d90efab277b2dd4a9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 00:53:40 2010 -0400

    Print the result of the depth-first search on all cells.

commit 8cf32e5fee8bd149f08a4796cb27818a41cbcdc5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 00:46:12 2010 -0400

    Const-ness.

commit d4aaac828a3b58c06ba1218645669563221e961c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 00:42:24 2010 -0400

    Better debug statements.

commit 200dd5cff8bcea20cdee27c2c533078cab0135b3
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 00:32:44 2010 -0400

    Print cell names instead of cell pointers for debugging.

commit 078ee11347d135eb387fe8fb491ee88dc6a9e1e1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Tue Apr 13 00:23:29 2010 -0400

    Perform depth first search on all cells.

commit 798c05ec658d294128548f16436d318932d0116b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 10 22:52:41 2010 -0400

    Added another cell A6 to intentionally create two roots in the dependency tree.

commit b34a2ae0982cdf19087aabdd861b6c22657f6166
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Apr 10 22:39:53 2010 -0400

    More description for depends_tracker class.

commit e46b07ee8c4ab2f29f8823f27b0e02aeebfff850
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 29 09:34:42 2010 -0400

    Removed unused lines.

commit af73f07ecb227524e3dbe0a1a548b64ea41b7304
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 29 09:27:35 2010 -0400

    More exception safe depend cell insertion.

commit cd16f680f7b76d427db09f07cce03c53719a0335
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 29 01:24:39 2010 -0400

    Add javadoc comment

commit 2961503f985e076b0925007bffd6967358089b27
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 29 01:22:26 2010 -0400

    Generate dot graph script to show dependency graph.

commit 6c23c82da9ce5fc62064cae002cedea4ec97860a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 22:25:17 2010 -0400

    Pass cell dependency information to the dependency tracker.

commit 037126cc3f1be165030a3d711acb04fa9379ee0f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 21:56:29 2010 -0400

    Have formula parser pick up depende cells during parsing.

commit c341290c6e0e9eb9b089613a4ae7ec89977c21ae
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 20:08:04 2010 -0400

    More on dependency tracker.

commit 7c4c0912fac0ab5b5986c16bf48f3dc122605392
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 16:22:08 2010 -0400

    Renamed some files & fixed Makefile dependencies.

commit 120fdf8f7ffa23c486c71e61b7cab11f96397a00
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 16:16:57 2010 -0400

    Updated javadoc.

commit e952b6f4f3f0121f22882b387cafeb02c0551dd9
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 16:10:59 2010 -0400

    Make sure the formula parser no longer has tokens left.

commit 83bee8490320fe47747694cce8c907c437a195ad
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 28 15:54:34 2010 -0400

    Transfer formula tokens from the parser to the formula cell.

commit fea5addebf3191f3b9ef8926dc43e9c4ed18c4d8
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 21:52:03 2010 -0400

    Removed compiler warnings on enum switch statements.

commit 18b3aa10288bbdb60801ca69f5677fb888c7dbc6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 17:33:30 2010 -0400

    Initial work on formula parser.  Pick up single cell references.

commit e59dac8694f895d8025dd5db98b4a3326d401d82
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 13:03:38 2010 -0400

    Added swap_tokens method.

commit a21d9e4b640d0b3a669d06a14a45074bc0e66dce
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 12:07:00 2010 -0400

    Removed in-line TODO.

commit 5f83624e5c7c6cb42e386a0948cdaab6fe74c081
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 12:03:58 2010 -0400

    Check to ensure no duplicate cell names exist before creating formula_cell instances.

commit 4cfe381c1162e377231bdac3051ff20e4b2390e1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 11:35:26 2010 -0400

    Pass the cell name map instance to formula_parser instances.

commit 2610b9cfc7a3069d43515da21953e058f19da278
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 11:29:23 2010 -0400

    The name to pointer map needs to store base_cell pointers.

commit 4f17b83cd43053617e2cdee2f1ef7204aeb0a658
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 20 11:18:30 2010 -0400

    Create a set of empty formula cell instances associated with their names.
    
    We need to have the pointers to formula cells instances before converting
    the lexer tokens to formula tokens, in order to resolve cell references
    correctly.

commit d3908e1740418980411597e3f355f00fb71b28d0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 19:39:26 2010 -0400

    More on dependency tracker.

commit 9bdb58654b887593be916b442649a6fbbf1dfeda
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 18:44:06 2010 -0400

    Skeleton files for class dep_tracker that tracks cell dependencies.

commit 8529be3e9d9296778e95280154618087c74aeb92
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 18:32:51 2010 -0400

    More on formula parser.

commit 827a6f908f861f5f04d6719e34f1b6464ad96f9d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 18:20:30 2010 -0400

    renamed tokens_foo to lexer_tokens_foo.

commit ce6fecb90f022166793a8f9e6285c1bc46067e6f
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 18:04:32 2010 -0400

    added new files for formula tokens.
    
    Formula tokens differ from lexer tokens, therefore should use different
    types to represent them.

commit 73912c5fd3d5472ac832ccd81c2bbeab2179bd85
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 17:24:51 2010 -0400

    model_parser should use model_parser::cell class to record cell tokens.

commit c31d0d7da3f730c3dd5fedff64905f83f9806d97
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 17:03:19 2010 -0400

    changed oc_foo to op_foo in opcode names.

commit 81a4d3651f60c50bf30f379b290cfaddd6b4bc9a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 16:49:40 2010 -0400

    Moved code around a bit.

commit b4827e8c2ba495be03016e65ca7902951bd880c7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 16:41:40 2010 -0400

    Forgot to add virtual keyword to print().

commit ac105dc506ba643f861f2f2fc19b16cc5aefc783
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 15:41:06 2010 -0400

    Added skeletons for the new formula parser class.

commit b4c7eaa177203502e0013c262ac80b5e5602c41d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 10:38:40 2010 -0400

    A little cleanup by removing duplicated code block.

commit bc05f8a4d040f9c50269c91210dc008ce2986961
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Thu Mar 18 10:22:53 2010 -0400

    Handle command line arguments correctly, without throwing exceptions.

commit 3ae18e277702bdaf75a9ea67e8527175badfafed
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Mon Mar 15 00:32:33 2010 -0400

    Added license header to Makefile.

commit 9747930f5c57ccc09fef3fc0e9e19d07b4981499
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 23:58:12 2010 -0400

    print cell names

commit 2a1455bd1f81d0542fdf762137da87d75fa5f858
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 23:56:10 2010 -0400

    Introduced base_cell.

commit 1d6560708e08755613f5f9f43cbcaa551a2cd060
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 23:43:30 2010 -0400

    model_parser now stores list of formula cells.

commit b1c9294ea3dc8ba7342dd95880c5c24eb4f3474c
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 23:24:29 2010 -0400

    Use token class for generic opcode only tokens, and make token_base an abstract class.

commit eada2f7020fdf086ea6576cc26999ae51706df7b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 20:53:24 2010 -0400

    Handle parentheses.

commit 479287b320918aae52f1849d0c48a2ea95e85bcd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 20:36:31 2010 -0400

    Renamed a model input file.

commit a4e37526b1a614b24a205972f3fa47f48835446a
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 20:45:15 2010 -0400

    More detailed token printing.

commit aedaaf8302a83d952880cc929a38b486442f162d
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 20:32:30 2010 -0400

    Handle string tokens.

commit 4214155a129eb1195b46c842747db47add80b7c6
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 17:09:31 2010 -0400

    More on tokenization.

commit 240823c47586a3513036da8b950391331f4e76a1
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 16:41:14 2010 -0400

    Pick up numerals as value tokens.

commit 50617f3be0c29d879ec0168e184dfd4d98d095fd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 14:46:00 2010 -0400

    Track current characters as a data member.

commit f48e32f5eef8faed562d28a11b81f3c34a80aebd
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 14:04:10 2010 -0400

    Main loop for tokenizer.

commit 0e09385326b920b3da297bbffba8d6f55b70f676
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 13:28:49 2010 -0400

    Tokenize formula strings when parsing input.

commit 5009653217a5586662c93c7d915c97a98acbb997
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 11:46:14 2010 -0400

    Swap tokens from lexer to cell.

commit 0a7eee14e61ed8468257f6108c014687e6e94b6b
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 11:39:38 2010 -0400

    Added source files for global symbols.

commit 4b7108df599a2feb826ce0468b3a258229f36369
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 10:49:52 2010 -0400

    renamed cell to string_cell.

commit 26a2a75b30e65a47699ad8a536fa6bd4a8b521a0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 10:35:54 2010 -0400

    added formula lexer source files.

commit f4d738d483b172e3a03993ca6a4e862b169ba8d0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 01:23:32 2010 -0500

    More on model input parsing.

commit 60a1ef0a5998d7722b740d69d2969ad58ced3a10
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 01:14:27 2010 -0500

    Fixed parse error on model input parsing.

commit 98eb994de4f13a1068ee15a2ff34afbcda24dff7
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sun Mar 14 00:41:48 2010 -0500

    More on model parsing.

commit be5548f6619b8dd4e102b90d4544eaa661fb9b62
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 23:45:41 2010 -0500

    Added skeletons for cell and tokens_base.

commit bd2360650d33c1bbd55e1b14204aaa79d28acf15
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 22:54:01 2010 -0500

    Added model parser main loop.

commit 97b321aff45659923e41cedb4d30414a121c4a58
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 22:04:37 2010 -0500

    More on model parser.  Added simple test input file.

commit 126d859dba6e59d5b664966dec8718fc15e2a7e5
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 21:17:08 2010 -0500

    Added main.cpp.

commit 05b7c69fcc5c824cb2d6e8e5adbbb269823b66e0
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 20:44:46 2010 -0500

    Initial skeleton for model input parser executable.

commit 43747fea3ca218d60d69d03dec75ead225e70bea
Author: Kohei Yoshida <kyoshida@novell.com>
Date:   Sat Mar 13 20:20:44 2010 -0500

    Added README.
